// {{{RME classifier 'Logical View::VANT::VCTRL::VCONT::Aileron'

#ifndef Aileron_H
#define Aileron_H

#ifdef PRAGMA
#pragma interface "Aileron.h"
#endif

#include <RTSystem/VANT.h>
#include <Aileron_Protocol.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass Aileron;

#define SUPER RTActor
class Aileron_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'aileron_status'
	int aileron_status;
	// }}}RME

protected:
	// {{{RME port 'to_controller'
	Aileron_Protocol::Conjugate to_controller;
	// }}}RME

public:
	Aileron_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~Aileron_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Active:J4359E960009C:request_status'
	INLINE_METHODS void transition2_request_status( const void * rtdata, Aileron_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359E97003A9:do_left'
	INLINE_METHODS void transition3_do_left( const void * rtdata, Aileron_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359E9A00021:do_right'
	INLINE_METHODS void transition4_do_right( const void * rtdata, Aileron_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359E9E2013A:do_straight'
	INLINE_METHODS void transition5_do_straight( const void * rtdata, Aileron_Protocol::Conjugate * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_request_status( void );
	INLINE_CHAINS void chain4_do_right( void );
	INLINE_CHAINS void chain3_do_left( void );
	INLINE_CHAINS void chain5_do_straight( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_Aileron_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* Aileron_H */

// }}}RME
