// {{{RME classifier 'Logical View::VANT::VCTRL::VCONT::Aileron_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Aileron_Protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <Aileron_Protocol.h>

const RTProtocolDescriptor Aileron_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Aileron_Protocol::Conjugate::rt_class
  , "Aileron_Protocol"
  , 0
  , 3
  , Aileron_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Aileron_Protocol::Base::rt_signals[] =
{
	{
		"aileron_status"
	  , &RTType_int
	  , Aileron_Protocol::Base::rti_aileron_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Aileron_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Aileron_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Aileron_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Aileron_Protocol::Base::rt_class
  , "Aileron_Protocol"
  , 0
  , 6
  , Aileron_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Aileron_Protocol::Conjugate::rt_signals[] =
{
	{
		"do_aileron_left"
	  , &RTType_void
	  , Aileron_Protocol::Conjugate::rti_do_aileron_left
	}
  , {
		"do_aileron_right"
	  , &RTType_void
	  , Aileron_Protocol::Conjugate::rti_do_aileron_right
	}
  , {
		"do_aileron_straight"
	  , &RTType_void
	  , Aileron_Protocol::Conjugate::rti_do_aileron_straight
	}
  , {
		"request_aileron_status"
	  , &RTType_void
	  , Aileron_Protocol::Conjugate::rti_request_aileron_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Aileron_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Aileron_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
