// {{{RME classifier 'Logical View::VANT::VCTRL::VCONT::Aileron_Protocol'

#ifndef Aileron_Protocol_H
#define Aileron_Protocol_H

#ifdef PRAGMA
#pragma interface "Aileron_Protocol.h"
#endif

#include <RTSystem/VANT.h>

struct Aileron_Protocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_aileron_status = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Aileron_Protocol = rti_aileron_status };

	public:
		inline RTInSignal aileron_status( void );
		inline RTOutSignal request_aileron_status( void );
		inline RTOutSignal do_aileron_right( void );
		inline RTOutSignal do_aileron_left( void );
		inline RTOutSignal do_aileron_straight( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_request_aileron_status = rtiLast_RTRootProtocol + 1
		  , rti_do_aileron_right
		  , rti_do_aileron_left
		  , rti_do_aileron_straight
		};

	protected:
		enum { rtiLast_Aileron_Protocol = rti_do_aileron_straight };

	public:
		inline RTInSignal request_aileron_status( void );
		inline RTInSignal do_aileron_right( void );
		inline RTInSignal do_aileron_left( void );
		inline RTInSignal do_aileron_straight( void );
		inline RTOutSignal aileron_status( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline Aileron_Protocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline Aileron_Protocol::Base::~Base( void )
{
}

inline RTInSignal Aileron_Protocol::Base::aileron_status( void )
{
	return RTInSignal( this, rti_aileron_status );
}

inline RTOutSignal Aileron_Protocol::Base::request_aileron_status( void )
{
	return RTOutSignal( this, Conjugate::rti_request_aileron_status, (const void *)0, &RTType_void );
}

inline RTOutSignal Aileron_Protocol::Base::do_aileron_right( void )
{
	return RTOutSignal( this, Conjugate::rti_do_aileron_right, (const void *)0, &RTType_void );
}

inline RTOutSignal Aileron_Protocol::Base::do_aileron_left( void )
{
	return RTOutSignal( this, Conjugate::rti_do_aileron_left, (const void *)0, &RTType_void );
}

inline RTOutSignal Aileron_Protocol::Base::do_aileron_straight( void )
{
	return RTOutSignal( this, Conjugate::rti_do_aileron_straight, (const void *)0, &RTType_void );
}

inline Aileron_Protocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline Aileron_Protocol::Conjugate::~Conjugate( void )
{
}

inline RTInSignal Aileron_Protocol::Conjugate::request_aileron_status( void )
{
	return RTInSignal( this, rti_request_aileron_status );
}

inline RTInSignal Aileron_Protocol::Conjugate::do_aileron_right( void )
{
	return RTInSignal( this, rti_do_aileron_right );
}

inline RTInSignal Aileron_Protocol::Conjugate::do_aileron_left( void )
{
	return RTInSignal( this, rti_do_aileron_left );
}

inline RTInSignal Aileron_Protocol::Conjugate::do_aileron_straight( void )
{
	return RTInSignal( this, rti_do_aileron_straight );
}

inline RTOutSignal Aileron_Protocol::Conjugate::aileron_status( const int & data )
{
	return RTOutSignal( this, Base::rti_aileron_status, &data, &RTType_int );
}

#endif /* Aileron_Protocol_H */

// }}}RME
