// {{{RME classifier 'Logical View::VANT::VCNS::VCOM::COM_PROTOCOL'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "COM_PROTOCOL.h"
#endif

#include <RTSystem/VANT.h>
#include <COM_PROTOCOL.h>

const RTProtocolDescriptor COM_PROTOCOL::Base::rt_class =
{
	&PMission::Base::rt_class
  , &COM_PROTOCOL::Conjugate::rt_class
  , "COM_PROTOCOL"
  , 0
  , 13
  , COM_PROTOCOL::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor COM_PROTOCOL::Base::rt_signals[] =
{
	{
		"final_position"
	  , &RTType_Coordinate
	  , COM_PROTOCOL::Base::rti_final_position
	}
  , {
		"mission_speed"
	  , &RTType_int
	  , COM_PROTOCOL::Base::rti_mission_speed
	}
  , {
		"mission_time"
	  , &RTType_int
	  , COM_PROTOCOL::Base::rti_mission_time
	}
  , {
		"requestMission"
	  , &RTType_MissionVant
	  , COM_PROTOCOL::Base::rti_requestMission
	}
  , {
		"request_alarm_data"
	  , &RTType_int
	  , COM_PROTOCOL::Base::rti_request_alarm_data
	}
  , {
		"request_flight_data"
	  , &RTType_int
	  , COM_PROTOCOL::Base::rti_request_flight_data
	}
  , {
		"request_fuel_level"
	  , &RTType_int
	  , COM_PROTOCOL::Base::rti_request_fuel_level
	}
  , {
		"request_image_data"
	  , &RTType_rgb
	  , COM_PROTOCOL::Base::rti_request_image_data
	}
  , {
		"request_positioning_value"
	  , &RTType_Coordinate
	  , COM_PROTOCOL::Base::rti_request_positioning_value
	}
  , {
		"request_speed_value"
	  , &RTType_int
	  , COM_PROTOCOL::Base::rti_request_speed_value
	}
  , {
		"request_traj_data"
	  , &RTType_int
	  , COM_PROTOCOL::Base::rti_request_traj_data
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , COM_PROTOCOL::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , COM_PROTOCOL::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor COM_PROTOCOL::Conjugate::rt_class =
{
	&PMission::Conjugate::rt_class
  , &COM_PROTOCOL::Base::rt_class
  , "COM_PROTOCOL"
  , 0
  , 14
  , COM_PROTOCOL::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor COM_PROTOCOL::Conjugate::rt_signals[] =
{
	{
		"alarm_data"
	  , &RTType_int
	  , COM_PROTOCOL::Conjugate::rti_alarm_data
	}
  , {
		"final_position"
	  , &RTType_Coordinate
	  , COM_PROTOCOL::Conjugate::rti_final_position
	}
  , {
		"flight_data"
	  , &RTType_int
	  , COM_PROTOCOL::Conjugate::rti_flight_data
	}
  , {
		"fuel_level"
	  , &RTType_int
	  , COM_PROTOCOL::Conjugate::rti_fuel_level
	}
  , {
		"image_data"
	  , &RTType_rgb
	  , COM_PROTOCOL::Conjugate::rti_image_data
	}
  , {
		"mission_speed"
	  , &RTType_int
	  , COM_PROTOCOL::Conjugate::rti_mission_speed
	}
  , {
		"mission_time"
	  , &RTType_int
	  , COM_PROTOCOL::Conjugate::rti_mission_time
	}
  , {
		"positioning_value"
	  , &RTType_Coordinate
	  , COM_PROTOCOL::Conjugate::rti_positioning_value
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , COM_PROTOCOL::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , COM_PROTOCOL::Conjugate::rti_rtUnbound
	}
  , {
		"sendMission"
	  , &RTType_MissionVant
	  , COM_PROTOCOL::Conjugate::rti_sendMission
	}
  , {
		"speed_value"
	  , &RTType_int
	  , COM_PROTOCOL::Conjugate::rti_speed_value
	}
  , {
		"toFlightControl"
	  , &RTType_char
	  , COM_PROTOCOL::Conjugate::rti_toFlightControl
	}
  , {
		"traj_data"
	  , &RTType_Coordinate
	  , COM_PROTOCOL::Conjugate::rti_traj_data
	}
};

// }}}RME
