// {{{RME classifier 'Logical View::VANT::VCNS::VNAV::Cap_VNAV'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Cap_VNAV.h"
#endif

#include <RTSystem/VANT.h>
#include <Cap_VNAV.h>
#include <NAV_PROTOCOL.h>
#include <Navigation_Plan_Protocol.h>
extern const RTActorClass NAV_Controller;
extern const RTActorClass Navigation_Plan;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"to_bus"
	  , &NAV_PROTOCOL::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_Cap_VNAV_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new Cap_VNAV_Actor( _rts, _ref );
}

const RTActorClass Cap_VNAV =
{
	(const RTActorClass *)0
  , "Cap_VNAV"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_Cap_VNAV_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_nav_Controller[] =
{
	{
		"to_bus"
	  , 1
	}
  , {
		"from_controller"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_nav_Controller[] =
{
	{
		0
	  , &NAV_PROTOCOL::Base::rt_class
	}
  , {
		1
	  , &Navigation_Plan_Protocol::Conjugate::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_navigation_Plan[] =
{
	{
		"to_controller"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_navigation_Plan[] =
{
	{
		0
	  , &Navigation_Plan_Protocol::Base::rt_class
	}
};

#define SUPER RTActor

Cap_VNAV_Actor::Cap_VNAV_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

Cap_VNAV_Actor::~Cap_VNAV_Actor( void )
{
}

int Cap_VNAV_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// to_bus
		if( rtg_repIndex < 1 )
		{
			// nav_Controller/to_bus
			return nav_Controller._followIn( rtg_end, 0, rtg_repIndex );
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

int Cap_VNAV_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// nav_Controller
		switch( rtg_portId )
		{
		case 0:
			// to_bus
			if( rtg_repIndex < 1 )
			{
				// to_bus
				return _followOut( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// from_controller
			if( rtg_repIndex < 1 )
			{
				// navigation_Plan/to_controller
				return navigation_Plan._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 2:
		// navigation_Plan
		switch( rtg_portId )
		{
		case 0:
			// to_controller
			if( rtg_repIndex < 1 )
			{
				// nav_Controller/from_controller
				return nav_Controller._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void Cap_VNAV_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * Cap_VNAV_Actor::getActorData( void ) const
{
	return &Cap_VNAV_Actor::rtg_class;
}

const RTActor_class Cap_VNAV_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , Cap_VNAV_Actor::rtg_parent_state
  , &Cap_VNAV
  , 2
  , Cap_VNAV_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId Cap_VNAV_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor Cap_VNAV_Actor::rtg_capsule_roles[] =
{
	{
		"nav_Controller"
	  , &NAV_Controller
	  , RTOffsetOf( Cap_VNAV_Actor, nav_Controller )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 2
	  , rtg_interfaces_nav_Controller
	  , 2
	  , rtg_bindings_nav_Controller
	}
  , {
		"navigation_Plan"
	  , &Navigation_Plan
	  , RTOffsetOf( Cap_VNAV_Actor, navigation_Plan )
	  , 2
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_navigation_Plan
	  , 1
	  , rtg_bindings_navigation_Plan
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
