// {{{RME classifier 'Logical View::VANT::VCTRL::VCOMB::Consume'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Consume.h"
#endif

#include <RTSystem/VANT.h>
#include <Consume.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"to_controller"
	  , &Consume_Protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_Consume_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new Consume_Actor( _rts, _ref );
}

const RTActorClass Consume =
{
	(const RTActorClass *)0
  , "Consume"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_Consume_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Active"
};

#define SUPER RTActor

Consume_Actor::Consume_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
	, consume_value( 0 )
{
}

Consume_Actor::~Consume_Actor( void )
{
}

int Consume_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// to_controller
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_controller;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:Active:J435994CB032E:request_consume'
INLINE_METHODS void Consume_Actor::transition2_request_consume( const void * rtdata, Consume_Protocol::Conjugate * rtport )
{
	// {{{USR
	to_controller.consume_value(consume_value).send();
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:Active:J435995B60050:increase_consume'
INLINE_METHODS void Consume_Actor::transition3_increase_consume( const void * rtdata, Consume_Protocol::Conjugate * rtport )
{
	// {{{USR
	consume_value +=20;
	if (consume_value >=100) 
	{
		consume_value = 100;
	}
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:Active:J4359968E0224:decrease_value'
INLINE_METHODS void Consume_Actor::transition4_decrease_value( const void * rtdata, Consume_Protocol::Conjugate * rtport )
{
	// {{{USR
	consume_value -=20;
	if (consume_value <=0)
	{
		consume_value=0;
	}
	// }}}USR
}
// }}}RME

INLINE_CHAINS void Consume_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void Consume_Actor::chain2_request_consume( void )
{
	// transition ':TOP:Active:J435994CB032E:request_consume'
	rtgChainBegin( 2, "request_consume" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition2_request_consume( msg->data, (Consume_Protocol::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void Consume_Actor::chain3_increase_consume( void )
{
	// transition ':TOP:Active:J435995B60050:increase_consume'
	rtgChainBegin( 2, "increase_consume" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition3_increase_consume( msg->data, (Consume_Protocol::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void Consume_Actor::chain4_decrease_value( void )
{
	// transition ':TOP:Active:J4359968E0224:decrease_value'
	rtgChainBegin( 2, "decrease_value" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition4_decrease_value( msg->data, (Consume_Protocol::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

void Consume_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:Active'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'to_controller'
				switch( signalIndex )
				{
				case Consume_Protocol::Conjugate::rti_request_fuel_consume:
					chain2_request_consume();
					return;
				case Consume_Protocol::Conjugate::rti_increase_consume:
					chain3_increase_consume();
					return;
				case Consume_Protocol::Conjugate::rti_decrease_consume:
					chain4_decrease_value();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * Consume_Actor::getActorData( void ) const
{
	return &Consume_Actor::rtg_class;
}

const RTActor_class Consume_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 2
  , Consume_Actor::rtg_parent_state
  , &Consume
  , 0
  , (const RTComponentDescriptor *)0
  , 1
  , Consume_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 1
  , Consume_Actor::rtg_Consume_fields
};

const RTStateId Consume_Actor::rtg_parent_state[] =
{
	0
  , 1
};

const RTPortDescriptor Consume_Actor::rtg_ports[] =
{
	{
		"to_controller"
	  , (const char *)0
	  , &Consume_Protocol::Conjugate::rt_class
	  , RTOffsetOf( Consume_Actor, Consume_Actor::to_controller )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};

const RTFieldDescriptor Consume_Actor::rtg_Consume_fields[] =
{
	// {{{RME classAttribute 'consume_value'
	{
		"consume_value"
	  , RTOffsetOf( Consume_Actor, consume_value )
		// {{{RME tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_int
		// }}}RME
		// {{{RME tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
