// {{{RME classifier 'Logical View::VANT::VCTRL::VCOMB::Consume_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Consume_Protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <Consume_Protocol.h>

const RTProtocolDescriptor Consume_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Consume_Protocol::Conjugate::rt_class
  , "Consume_Protocol"
  , 0
  , 3
  , Consume_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Consume_Protocol::Base::rt_signals[] =
{
	{
		"consume_value"
	  , &RTType_int
	  , Consume_Protocol::Base::rti_consume_value
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Consume_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Consume_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Consume_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Consume_Protocol::Base::rt_class
  , "Consume_Protocol"
  , 0
  , 5
  , Consume_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Consume_Protocol::Conjugate::rt_signals[] =
{
	{
		"decrease_consume"
	  , &RTType_void
	  , Consume_Protocol::Conjugate::rti_decrease_consume
	}
  , {
		"increase_consume"
	  , &RTType_void
	  , Consume_Protocol::Conjugate::rti_increase_consume
	}
  , {
		"request_fuel_consume"
	  , &RTType_void
	  , Consume_Protocol::Conjugate::rti_request_fuel_consume
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Consume_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Consume_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
