// {{{RME classifier 'Logical View::VANT::VCTRL::VPOTE::EprControl'

#ifndef EprControl_H
#define EprControl_H

#ifdef PRAGMA
#pragma interface "EprControl.h"
#endif

#include <RTSystem/VANT.h>
#include <Epr_Protocol.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass EprControl;

#define SUPER RTActor
class EprControl_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'epr_status'
	int epr_status;
	// }}}RME

protected:
	// {{{RME port 'to_controller'
	Epr_Protocol::Conjugate to_controller;
	// }}}RME

public:
	EprControl_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~EprControl_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Active:J4359EA40009E:request_epr'
	INLINE_METHODS void transition2_request_epr( const void * rtdata, Epr_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359EA9E0179:up'
	INLINE_METHODS void transition3_up( const void * rtdata, Epr_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359EAC200BD:down'
	INLINE_METHODS void transition4_down( const void * rtdata, Epr_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359EADC034B:straight'
	INLINE_METHODS void transition5_straight( const void * rtdata, Epr_Protocol::Conjugate * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain3_up( void );
	INLINE_CHAINS void chain4_down( void );
	INLINE_CHAINS void chain2_request_epr( void );
	INLINE_CHAINS void chain5_straight( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_EprControl_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* EprControl_H */

// }}}RME
