// {{{RME classifier 'Logical View::VANT::VCTRL::VPOTE::Epr_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Epr_Protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <Epr_Protocol.h>

const RTProtocolDescriptor Epr_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Epr_Protocol::Conjugate::rt_class
  , "Epr_Protocol"
  , 0
  , 3
  , Epr_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Epr_Protocol::Base::rt_signals[] =
{
	{
		"epr_status"
	  , &RTType_int
	  , Epr_Protocol::Base::rti_epr_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Epr_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Epr_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Epr_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Epr_Protocol::Base::rt_class
  , "Epr_Protocol"
  , 0
  , 6
  , Epr_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Epr_Protocol::Conjugate::rt_signals[] =
{
	{
		"do_epr_down"
	  , &RTType_void
	  , Epr_Protocol::Conjugate::rti_do_epr_down
	}
  , {
		"do_epr_up"
	  , &RTType_void
	  , Epr_Protocol::Conjugate::rti_do_epr_up
	}
  , {
		"do_straight"
	  , &RTType_void
	  , Epr_Protocol::Conjugate::rti_do_straight
	}
  , {
		"request_epr_status"
	  , &RTType_void
	  , Epr_Protocol::Conjugate::rti_request_epr_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Epr_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Epr_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
