// {{{RME classifier 'Logical View::VANT::VCTRL::VCOMB::FuelController'

#ifndef FuelController_H
#define FuelController_H

#ifdef PRAGMA
#pragma interface "FuelController.h"
#endif

#include <RTSystem/VANT.h>
#include <Bus_Comb_Protocol.h>
#include <Consume_Protocol.h>
#include <Level_Protocol.h>
#include <Mix_Protocol.h>
#include <Power_Comb_Protocol.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass FuelController;

#define SUPER RTActor
class FuelController_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME port 'to_bus'
	Bus_Comb_Protocol::Conjugate to_bus;
	// }}}RME
	// {{{RME port 'to_power'
	Power_Comb_Protocol::Conjugate to_power;
	// }}}RME
	// {{{RME port 'to_consume'
	Consume_Protocol::Base to_consume;
	// }}}RME
	// {{{RME port 'to_mix'
	Mix_Protocol::Base to_mix;
	// }}}RME
	// {{{RME port 'to_level'
	Level_Protocol::Base to_level;
	// }}}RME
	// {{{RME port 'timer'
	Timing::Base timer;
	// }}}RME

public:
	FuelController_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~FuelController_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Active:J4359B2AE0214:request_consume'
	INLINE_METHODS void transition2_request_consume( const void * rtdata, Bus_Comb_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359B5000197:request_bus_level'
	INLINE_METHODS void transition3_request_bus_level( const void * rtdata, Bus_Comb_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Process_Bus_Consume_Request:J4359B6130158:consume_to_bus'
	INLINE_METHODS void transition4_consume_to_bus( const int * rtdata, Consume_Protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Process_Bus_Level_Request:J4359B64E0223:level_to_bus'
	INLINE_METHODS void transition5_level_to_bus( const int * rtdata, Level_Protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359B780037B:request_mix'
	INLINE_METHODS void transition6_request_mix( const void * rtdata, Bus_Comb_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Process_Bus_Mix_Request:J4359B7D202DF:mix_to_bus'
	INLINE_METHODS void transition7_mix_to_bus( const bool * rtdata, Mix_Protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359BA6001A6:request_consume_power'
	INLINE_METHODS void transition8_request_consume_power( const void * rtdata, Power_Comb_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359BA7D0158:request_mix_power'
	INLINE_METHODS void transition9_request_mix_power( const void * rtdata, Power_Comb_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359BA94007D:request_level_power'
	INLINE_METHODS void transition10_request_level_power( const void * rtdata, Power_Comb_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Process_Power_Consume_Request:J4359BAB8034C:consume_to_power'
	INLINE_METHODS void transition11_consume_to_power( const int * rtdata, Consume_Protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Process_Power_Mix_Request:J4359BAD6039A:mix_to_power'
	INLINE_METHODS void transition12_mix_to_power( const bool * rtdata, Mix_Protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Process_Power_Level_Request:J4359BAE70290:level_to_power'
	INLINE_METHODS void transition13_level_to_power( const int * rtdata, Level_Protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359BDF30010:unload'
	INLINE_METHODS void transition14_unload( const void * rtdata, Bus_Comb_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Process_Unload:J4359BE4302D0:unload'
	INLINE_METHODS void transition15_unload( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359C0010169:decrease_flow'
	INLINE_METHODS void transition16_decrease_flow( const void * rtdata, Power_Comb_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359C0820244:increase_flow'
	INLINE_METHODS void transition17_increase_flow( const void * rtdata, Power_Comb_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359C68E00AB:engine_on'
	INLINE_METHODS void transition18_engine_on( const void * rtdata, Power_Comb_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359C6CF0273:engine_off'
	INLINE_METHODS void transition19_engine_off( const void * rtdata, Power_Comb_Protocol::Conjugate * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_request_consume( void );
	INLINE_CHAINS void chain6_request_mix( void );
	INLINE_CHAINS void chain3_request_bus_level( void );
	INLINE_CHAINS void chain14_unload( void );
	INLINE_CHAINS void chain10_request_level_power( void );
	INLINE_CHAINS void chain8_request_consume_power( void );
	INLINE_CHAINS void chain9_request_mix_power( void );
	INLINE_CHAINS void chain17_increase_flow( void );
	INLINE_CHAINS void chain16_decrease_flow( void );
	INLINE_CHAINS void chain18_engine_on( void );
	INLINE_CHAINS void chain19_engine_off( void );
	INLINE_CHAINS void chain4_consume_to_bus( void );
	INLINE_CHAINS void chain5_level_to_bus( void );
	INLINE_CHAINS void chain7_mix_to_bus( void );
	INLINE_CHAINS void chain13_level_to_power( void );
	INLINE_CHAINS void chain12_mix_to_power( void );
	INLINE_CHAINS void chain11_consume_to_power( void );
	INLINE_CHAINS void chain15_unload( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* FuelController_H */

// }}}RME
