// {{{RME classifier 'Logical View::VANT::VCTRL::VCOMB::Level'

#ifndef Level_H
#define Level_H

#ifdef PRAGMA
#pragma interface "Level.h"
#endif

#include <RTSystem/VANT.h>
#include <Level_Protocol.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass Level;

#define SUPER RTActor
class Level_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'level_value'
	int level_value;
	// }}}RME
	// {{{RME classAttribute 'level_factor'
	int level_factor;
	// }}}RME
	// {{{RME classAttribute 'tid'
	RTTimerId tid;
	// }}}RME

protected:
	// {{{RME port 'to_controller'
	Level_Protocol::Conjugate to_controller;
	// }}}RME
	// {{{RME port 'timer'
	Timing::Base timer;
	// }}}RME

public:
	Level_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~Level_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Active:J43599F9403A9:request_level'
	INLINE_METHODS void transition1_request_level( const void * rtdata, Level_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359A17E0177:engine_on'
	INLINE_METHODS void transition3_engine_on( const void * rtdata, Level_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359A2080253:decrement'
	INLINE_METHODS void transition4_decrement( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359BF33039B:unload'
	INLINE_METHODS void transition5_unload( const void * rtdata, Level_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Active:J4359C73B03AB:engine_off'
	INLINE_METHODS void transition6_engine_off( const void * rtdata, Level_Protocol::Conjugate * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain2_Initial( void );
	INLINE_CHAINS void chain1_request_level( void );
	INLINE_CHAINS void chain3_engine_on( void );
	INLINE_CHAINS void chain5_unload( void );
	INLINE_CHAINS void chain6_engine_off( void );
	INLINE_CHAINS void chain4_decrement( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_Level_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* Level_H */

// }}}RME
