// {{{RME classifier 'Logical View::VANT::VCTRL::VPOTE::ManetePower'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "ManetePower.h"
#endif

#include <RTSystem/VANT.h>
#include <ManetePower.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"to_controller"
	  , &Manete_Protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_ManetePower_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new ManetePower_Actor( _rts, _ref );
}

const RTActorClass ManetePower =
{
	(const RTActorClass *)0
  , "ManetePower"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_ManetePower_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Active"
};

#define SUPER RTActor

ManetePower_Actor::ManetePower_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
	, manete_status( 1 )
{
}

ManetePower_Actor::~ManetePower_Actor( void )
{
}

int ManetePower_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// to_controller
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_controller;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:Active:J4359EA40009E:request_manete'
INLINE_METHODS void ManetePower_Actor::transition2_request_manete( const void * rtdata, Manete_Protocol::Conjugate * rtport )
{
	// {{{USR
	to_controller.manete_status(manete_status).send();
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:Active:J4359EA9E0179:up'
INLINE_METHODS void ManetePower_Actor::transition3_up( const void * rtdata, Manete_Protocol::Conjugate * rtport )
{
	// {{{USR
	manete_status=2;
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:Active:J4359EAC200BD:down'
INLINE_METHODS void ManetePower_Actor::transition4_down( const void * rtdata, Manete_Protocol::Conjugate * rtport )
{
	// {{{USR
	manete_status=0;
	// }}}USR
}
// }}}RME

// {{{RME transition ':TOP:Active:J4359EADC034B:straight'
INLINE_METHODS void ManetePower_Actor::transition5_straight( const void * rtdata, Manete_Protocol::Conjugate * rtport )
{
	// {{{USR
	manete_status=1;
	// }}}USR
}
// }}}RME

INLINE_CHAINS void ManetePower_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void ManetePower_Actor::chain4_down( void )
{
	// transition ':TOP:Active:J4359EAC200BD:down'
	rtgChainBegin( 2, "down" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition4_down( msg->data, (Manete_Protocol::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void ManetePower_Actor::chain3_up( void )
{
	// transition ':TOP:Active:J4359EA9E0179:up'
	rtgChainBegin( 2, "up" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition3_up( msg->data, (Manete_Protocol::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void ManetePower_Actor::chain5_straight( void )
{
	// transition ':TOP:Active:J4359EADC034B:straight'
	rtgChainBegin( 2, "straight" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition5_straight( msg->data, (Manete_Protocol::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void ManetePower_Actor::chain2_request_manete( void )
{
	// transition ':TOP:Active:J4359EA40009E:request_manete'
	rtgChainBegin( 2, "request_manete" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition2_request_manete( msg->data, (Manete_Protocol::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

void ManetePower_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:Active'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'to_controller'
				switch( signalIndex )
				{
				case Manete_Protocol::Conjugate::rti_do_manete_down:
					chain4_down();
					return;
				case Manete_Protocol::Conjugate::rti_do_manete_up:
					chain3_up();
					return;
				case Manete_Protocol::Conjugate::rti_do_straight:
					chain5_straight();
					return;
				case Manete_Protocol::Conjugate::rti_request_manete_status:
					chain2_request_manete();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * ManetePower_Actor::getActorData( void ) const
{
	return &ManetePower_Actor::rtg_class;
}

const RTActor_class ManetePower_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 2
  , ManetePower_Actor::rtg_parent_state
  , &ManetePower
  , 0
  , (const RTComponentDescriptor *)0
  , 1
  , ManetePower_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 1
  , ManetePower_Actor::rtg_ManetePower_fields
};

const RTStateId ManetePower_Actor::rtg_parent_state[] =
{
	0
  , 1
};

const RTPortDescriptor ManetePower_Actor::rtg_ports[] =
{
	{
		"to_controller"
	  , (const char *)0
	  , &Manete_Protocol::Conjugate::rt_class
	  , RTOffsetOf( ManetePower_Actor, ManetePower_Actor::to_controller )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};

const RTFieldDescriptor ManetePower_Actor::rtg_ManetePower_fields[] =
{
	// {{{RME classAttribute 'manete_status'
	{
		"manete_status"
	  , RTOffsetOf( ManetePower_Actor, manete_status )
		// {{{RME tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_int
		// }}}RME
		// {{{RME tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
