// {{{RME classifier 'Logical View::VANT::VCTRL::VPOTE::Manete_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Manete_Protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <Manete_Protocol.h>

const RTProtocolDescriptor Manete_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Manete_Protocol::Conjugate::rt_class
  , "Manete_Protocol"
  , 0
  , 3
  , Manete_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Manete_Protocol::Base::rt_signals[] =
{
	{
		"manete_status"
	  , &RTType_int
	  , Manete_Protocol::Base::rti_manete_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Manete_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Manete_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Manete_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Manete_Protocol::Base::rt_class
  , "Manete_Protocol"
  , 0
  , 6
  , Manete_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Manete_Protocol::Conjugate::rt_signals[] =
{
	{
		"do_manete_down"
	  , &RTType_void
	  , Manete_Protocol::Conjugate::rti_do_manete_down
	}
  , {
		"do_manete_up"
	  , &RTType_void
	  , Manete_Protocol::Conjugate::rti_do_manete_up
	}
  , {
		"do_straight"
	  , &RTType_void
	  , Manete_Protocol::Conjugate::rti_do_straight
	}
  , {
		"request_manete_status"
	  , &RTType_void
	  , Manete_Protocol::Conjugate::rti_request_manete_status
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Manete_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Manete_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
