// {{{RME classifier 'Logical View::VANT::VCNS::VNAV::NAV_PROTOCOL'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "NAV_PROTOCOL.h"
#endif

#include <RTSystem/VANT.h>
#include <NAV_PROTOCOL.h>

const RTProtocolDescriptor NAV_PROTOCOL::Base::rt_class =
{
	&PMission::Base::rt_class
  , &NAV_PROTOCOL::Conjugate::rt_class
  , "NAV_PROTOCOL"
  , 0
  , 4
  , NAV_PROTOCOL::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor NAV_PROTOCOL::Base::rt_signals[] =
{
	{
		"requestMission"
	  , &RTType_MissionVant
	  , NAV_PROTOCOL::Base::rti_requestMission
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , NAV_PROTOCOL::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , NAV_PROTOCOL::Base::rti_rtUnbound
	}
  , {
		"traj_planned"
	  , &RTType_int
	  , NAV_PROTOCOL::Base::rti_traj_planned
	}
};

const RTProtocolDescriptor NAV_PROTOCOL::Conjugate::rt_class =
{
	&PMission::Conjugate::rt_class
  , &NAV_PROTOCOL::Base::rt_class
  , "NAV_PROTOCOL"
  , 0
  , 5
  , NAV_PROTOCOL::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor NAV_PROTOCOL::Conjugate::rt_signals[] =
{
	{
		"rtBound"
	  , (const RTObject_class *)0
	  , NAV_PROTOCOL::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , NAV_PROTOCOL::Conjugate::rti_rtUnbound
	}
  , {
		"sendMission"
	  , &RTType_MissionVant
	  , NAV_PROTOCOL::Conjugate::rti_sendMission
	}
  , {
		"toFlightControl"
	  , &RTType_char
	  , NAV_PROTOCOL::Conjugate::rti_toFlightControl
	}
  , {
		"traj_plan_request"
	  , &RTType_int
	  , NAV_PROTOCOL::Conjugate::rti_traj_plan_request
	}
};

// }}}RME
