// {{{RME classifier 'Logical View::VANT::VCNS::VNAV::Navigation_Plan'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Navigation_Plan.h"
#endif

#include <RTSystem/VANT.h>
#include <Navigation_Plan.h>
#include <Coordinate.h>
#include <Navigation_Data_Out.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"to_controller"
	  , &Navigation_Plan_Protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_Navigation_Plan_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new Navigation_Plan_Actor( _rts, _ref );
}

const RTActorClass Navigation_Plan =
{
	(const RTActorClass *)0
  , "Navigation_Plan"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_Navigation_Plan_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Active"
};

#define SUPER RTActor

Navigation_Plan_Actor::Navigation_Plan_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

Navigation_Plan_Actor::~Navigation_Plan_Actor( void )
{
}

int Navigation_Plan_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// to_controller
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_controller;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:Active:J436F5E70035D:traj_plan'
INLINE_METHODS void Navigation_Plan_Actor::transition2_traj_plan( const int * rtdata, Navigation_Plan_Protocol::Conjugate * rtport )
{
	// {{{USR
	//calculo de planejamento

	Navigation_Data_Out Nav;


	// posio futura
	Nav.Future_Position.Longitude = 100.0;
	Nav.Future_Position.Latitude = 100.0;
	Nav.Future_Position.Altitude = 1000.0;

	// Delta S
	Nav.DeltaS = 200.0;

	// numero de coordenadas da trajetria planejada
	Nav.Number_Coordinates_Trajectory = 5;


	to_controller.traj_planned(*rtdata).send();
	// }}}USR
}
// }}}RME

INLINE_CHAINS void Navigation_Plan_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void Navigation_Plan_Actor::chain2_traj_plan( void )
{
	// transition ':TOP:Active:J436F5E70035D:traj_plan'
	rtgChainBegin( 2, "traj_plan" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition2_traj_plan( (const int *)msg->data, (Navigation_Plan_Protocol::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

void Navigation_Plan_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME state ':TOP:Active'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME port 'to_controller'
				switch( signalIndex )
				{
				case Navigation_Plan_Protocol::Conjugate::rti_request_traj_plan:
					chain2_traj_plan();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * Navigation_Plan_Actor::getActorData( void ) const
{
	return &Navigation_Plan_Actor::rtg_class;
}

const RTActor_class Navigation_Plan_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 2
  , Navigation_Plan_Actor::rtg_parent_state
  , &Navigation_Plan
  , 0
  , (const RTComponentDescriptor *)0
  , 1
  , Navigation_Plan_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId Navigation_Plan_Actor::rtg_parent_state[] =
{
	0
  , 1
};

const RTPortDescriptor Navigation_Plan_Actor::rtg_ports[] =
{
	{
		"to_controller"
	  , (const char *)0
	  , &Navigation_Plan_Protocol::Conjugate::rt_class
	  , RTOffsetOf( Navigation_Plan_Actor, Navigation_Plan_Actor::to_controller )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
