// {{{RME classifier 'Logical View::VANT::Common::PMission'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "PMission.h"
#endif

#include <RTSystem/VANT.h>
#include <PMission.h>

const RTProtocolDescriptor PMission::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &PMission::Conjugate::rt_class
  , "PMission"
  , 0
  , 3
  , PMission::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor PMission::Base::rt_signals[] =
{
	{
		"requestMission"
	  , &RTType_MissionVant
	  , PMission::Base::rti_requestMission
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , PMission::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , PMission::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor PMission::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &PMission::Base::rt_class
  , "PMission"
  , 0
  , 3
  , PMission::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor PMission::Conjugate::rt_signals[] =
{
	{
		"rtBound"
	  , (const RTObject_class *)0
	  , PMission::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , PMission::Conjugate::rti_rtUnbound
	}
  , {
		"sendMission"
	  , &RTType_MissionVant
	  , PMission::Conjugate::rti_sendMission
	}
};

// }}}RME
