// {{{RME classifier 'Logical View::VANT::Common::PMission'

#ifndef PMission_H
#define PMission_H

#ifdef PRAGMA
#pragma interface "PMission.h"
#endif

#include <RTSystem/VANT.h>
#include <MissionVant.h>

struct PMission
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_requestMission = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_PMission = rti_requestMission };

	public:
		inline RTInSignal requestMission( void );
		inline RTOutSignal sendMission( const RTTypedValue_MissionVant & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum { rti_sendMission = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_PMission = rti_sendMission };

	public:
		inline RTInSignal sendMission( void );
		inline RTOutSignal requestMission( const RTTypedValue_MissionVant & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline PMission::Base::Base( void )
	: RTRootProtocol()
{
}

inline PMission::Base::~Base( void )
{
}

inline RTInSignal PMission::Base::requestMission( void )
{
	return RTInSignal( this, rti_requestMission );
}

inline RTOutSignal PMission::Base::sendMission( const RTTypedValue_MissionVant & data )
{
	return RTOutSignal( this, Conjugate::rti_sendMission, data.data, data.type );
}

inline PMission::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline PMission::Conjugate::~Conjugate( void )
{
}

inline RTInSignal PMission::Conjugate::sendMission( void )
{
	return RTInSignal( this, rti_sendMission );
}

inline RTOutSignal PMission::Conjugate::requestMission( const RTTypedValue_MissionVant & data )
{
	return RTOutSignal( this, Base::rti_requestMission, data.data, data.type );
}

#endif /* PMission_H */

// }}}RME
