// {{{RME classifier 'Logical View::VANT::VCTRL::VPOTE::PowerControl'

#ifndef PowerControl_H
#define PowerControl_H

#ifdef PRAGMA
#pragma interface "PowerControl.h"
#endif

#include <RTSystem/VANT.h>
#include <Bus_Power_Protocol.h>
#include <Egt_Protocol.h>
#include <Epr_Protocol.h>
#include <Manete_Protocol.h>
#include <Power_Comb_Protocol.h>
#include <Power_Cont_Protocol.h>
#include <Rpm_Protocol.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
#include <stdio.h>
// }}}USR
// }}}RME

extern const RTActorClass PowerControl;

#define SUPER RTActor
class PowerControl_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'valuepower'
	int valuepower;
	// }}}RME

protected:
	// {{{RME port 'to_bus'
	Bus_Power_Protocol::Base to_bus;
	// }}}RME
	// {{{RME port 'to_flygthcontrol'
	Power_Cont_Protocol::Base to_flygthcontrol;
	// }}}RME
	// {{{RME port 'to_epr'
	Epr_Protocol::Base to_epr;
	// }}}RME
	// {{{RME port 'to_egt'
	Egt_Protocol::Base to_egt;
	// }}}RME
	// {{{RME port 'to_rpm'
	Rpm_Protocol::Base to_rpm;
	// }}}RME
	// {{{RME port 'timer1'
	Timing::Base timer1;
	// }}}RME
	// {{{RME port 'timer2'
	Timing::Base timer2;
	// }}}RME
	// {{{RME port 'to_fuelcontrol'
	Power_Comb_Protocol::Base to_fuelcontrol;
	// }}}RME
	// {{{RME port 'to_manete'
	Manete_Protocol::Base to_manete;
	// }}}RME

public:
	PowerControl_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~PowerControl_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME enter ':TOP:IDLE'
	INLINE_METHODS void enter2_IDLE( void );
	// }}}RME
	virtual void enterStateV( void );
	// {{{RME enter ':TOP:START_POWER'
	INLINE_METHODS void enter3_START_POWER( void );
	// }}}RME
	// {{{RME enter ':TOP:TAKING_OFF_POWER'
	INLINE_METHODS void enter4_TAKING_OFF_POWER( void );
	// }}}RME
	// {{{RME enter ':TOP:LANDING_POWER'
	INLINE_METHODS void enter6_LANDING_POWER( void );
	// }}}RME
	// {{{RME transition ':TOP:IDLE:J4359EDC60139:to_start'
	INLINE_METHODS void transition2_to_start( const void * rtdata, Power_Cont_Protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:START_POWER:J4359F592007E:to_taking_off'
	INLINE_METHODS void transition3_to_taking_off( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:TAKING_OFF_POWER:J4359F64A02C0:to_normal'
	INLINE_METHODS void transition4_to_normal( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:NORMAL_FLIGHT_POWER:J4359F7890224:timer_power'
	INLINE_METHODS void transition5_timer_power( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:NORMAL_FLIGHT_POWER:J4359F81E00EC:powerhigh'
	INLINE_METHODS void transition6_powerhigh( const void * rtdata, Power_Cont_Protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:NORMAL_FLIGHT_POWER:J4359FA2F02CE:to_landing'
	INLINE_METHODS void transition7_to_landing( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:IDLE:J438324C402E0:t1'
	INLINE_METHODS void transition9_t1( const void * rtdata, Power_Cont_Protocol::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain9_t1( void );
	INLINE_CHAINS void chain2_to_start( void );
	INLINE_CHAINS void chain3_to_taking_off( void );
	INLINE_CHAINS void chain4_to_normal( void );
	INLINE_CHAINS void chain6_powerhigh( void );
	INLINE_CHAINS void chain7_to_landing( void );
	INLINE_CHAINS void chain5_timer_power( void );
	INLINE_CHAINS void chain8_t1( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_PowerControl_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* PowerControl_H */

// }}}RME
