// {{{RME classifier 'Logical View::VANT::VCTRL::VCOMB::Power_Comb_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Power_Comb_Protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <Power_Comb_Protocol.h>

const RTProtocolDescriptor Power_Comb_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Power_Comb_Protocol::Conjugate::rt_class
  , "Power_Comb_Protocol"
  , 0
  , 7
  , Power_Comb_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Power_Comb_Protocol::Base::rt_signals[] =
{
	{
		"consume_value"
	  , &RTType_int
	  , Power_Comb_Protocol::Base::rti_consume_value
	}
  , {
		"flow_decreased"
	  , &RTType_void
	  , Power_Comb_Protocol::Base::rti_flow_decreased
	}
  , {
		"flow_increased"
	  , &RTType_void
	  , Power_Comb_Protocol::Base::rti_flow_increased
	}
  , {
		"level_value"
	  , &RTType_int
	  , Power_Comb_Protocol::Base::rti_level_value
	}
  , {
		"mix_value"
	  , &RTType_bool
	  , Power_Comb_Protocol::Base::rti_mix_value
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Power_Comb_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Power_Comb_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Power_Comb_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Power_Comb_Protocol::Base::rt_class
  , "Power_Comb_Protocol"
  , 0
  , 9
  , Power_Comb_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Power_Comb_Protocol::Conjugate::rt_signals[] =
{
	{
		"decrease_flow"
	  , &RTType_void
	  , Power_Comb_Protocol::Conjugate::rti_decrease_flow
	}
  , {
		"engine_off"
	  , &RTType_void
	  , Power_Comb_Protocol::Conjugate::rti_engine_off
	}
  , {
		"engine_on"
	  , &RTType_void
	  , Power_Comb_Protocol::Conjugate::rti_engine_on
	}
  , {
		"increase_flow"
	  , &RTType_void
	  , Power_Comb_Protocol::Conjugate::rti_increase_flow
	}
  , {
		"request_fuel_consume"
	  , &RTType_void
	  , Power_Comb_Protocol::Conjugate::rti_request_fuel_consume
	}
  , {
		"request_fuel_level"
	  , &RTType_void
	  , Power_Comb_Protocol::Conjugate::rti_request_fuel_level
	}
  , {
		"request_fuel_mix"
	  , &RTType_void
	  , Power_Comb_Protocol::Conjugate::rti_request_fuel_mix
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Power_Comb_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Power_Comb_Protocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
