// {{{RME classifier 'Logical View::VANT::Common::RW_VANT'

#ifndef RW_VANT_H
#define RW_VANT_H

#ifdef PRAGMA
#pragma interface "RW_VANT.h"
#endif

#include <RTSystem/VANT.h>
#include <RW_BAR.h>

struct RW_VANT
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum
		{
			rti_Read = rtiLast_RTRootProtocol + 1
		  , rti_Write
		};

	protected:
		enum { rtiLast_RW_VANT = rti_Write };

	public:
		inline RTInSignal Read( void );
		inline RTInSignal Write( void );
		inline RTOutSignal ReadOUT( const RTTypedValue_RW_BAR & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum { rti_ReadOUT = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_RW_VANT = rti_ReadOUT };

	public:
		inline RTInSignal ReadOUT( void );
		inline RTOutSignal Read( const char & data );
		inline RTOutSignal Write( const RTTypedValue_RW_BAR & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline RW_VANT::Base::Base( void )
	: RTRootProtocol()
{
}

inline RW_VANT::Base::~Base( void )
{
}

inline RTInSignal RW_VANT::Base::Read( void )
{
	return RTInSignal( this, rti_Read );
}

inline RTInSignal RW_VANT::Base::Write( void )
{
	return RTInSignal( this, rti_Write );
}

inline RTOutSignal RW_VANT::Base::ReadOUT( const RTTypedValue_RW_BAR & data )
{
	return RTOutSignal( this, Conjugate::rti_ReadOUT, data.data, data.type );
}

inline RW_VANT::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline RW_VANT::Conjugate::~Conjugate( void )
{
}

inline RTInSignal RW_VANT::Conjugate::ReadOUT( void )
{
	return RTInSignal( this, rti_ReadOUT );
}

inline RTOutSignal RW_VANT::Conjugate::Read( const char & data )
{
	return RTOutSignal( this, Base::rti_Read, &data, &RTType_char );
}

inline RTOutSignal RW_VANT::Conjugate::Write( const RTTypedValue_RW_BAR & data )
{
	return RTOutSignal( this, Base::rti_Write, data.data, data.type );
}

#endif /* RW_VANT_H */

// }}}RME
