// {{{RME classifier 'Logical View::VANT::VSUP::VCXP::RegistrarParametro'

#ifndef RegistrarParametro_H
#define RegistrarParametro_H

#ifdef PRAGMA
#pragma interface "RegistrarParametro.h"
#endif

#include <RTSystem/VANT.h>
#include <vcxp_protocol.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
#include<stdio.h>
// }}}USR
// }}}RME

extern const RTActorClass RegistrarParametro;

#define SUPER RTActor
class RegistrarParametro_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'status'
	bool status;
	// }}}RME
	// {{{RME classAttribute 'vlrParametro'
	char vlrParametro;
	// }}}RME
	// {{{RME classAttribute 'hora'
	int hora;
	// }}}RME

protected:
	// {{{RME port 'timer'
	Timing::Base timer;
	// }}}RME
	// {{{RME port 'roll'
	vcxp_protocol::Base roll;
	// }}}RME
	// {{{RME port 'angle'
	vcxp_protocol::Base angle;
	// }}}RME
	// {{{RME port 'heading'
	vcxp_protocol::Base heading;
	// }}}RME
	// {{{RME port 'outUSC'
	vcxp_protocol::Base outUSC;
	// }}}RME

public:
	RegistrarParametro_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~RegistrarParametro_Actor( void );

protected:
	// {{{RME operation 'Validar()'
	void Validar( void );
	// }}}RME
	// {{{RME operation 'Empacotar()'
	void Empacotar( void );
	// }}}RME
	// {{{RME operation 'Registrar()'
	void Registrar( void );
	// }}}RME

public:
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Initial:Initial'
	INLINE_METHODS void transition1_Initial( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Espera:J4354E79E003F:t1'
	INLINE_METHODS void transition2_t1( const int * rtdata, vcxp_protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:RegistrarParametro:J4354E8100178:t1'
	INLINE_METHODS void transition3_t1( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:EmpacotarParametro:J4354E813036C:t1'
	INLINE_METHODS void transition4_t1( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:CapturarParametro:J4354E81A001F:t1'
	INLINE_METHODS void transition5_t1( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:ValidarParametro:J4356351C0252:t1'
	INLINE_METHODS void transition6_t1( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:IsValid:True'
	INLINE_METHODS void transition7_True( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:IsValid:False'
	INLINE_METHODS void transition8_False( const void * rtdata, Timing::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_t1( void );
	INLINE_CHAINS void chain5_t1( void );
	INLINE_CHAINS void chain6_t1( void );

protected:
	// {{{RME choicePoint ':TOP:IsValid'
	INLINE_METHODS int choicePoint1_IsValid( const void * rtdata, Timing::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain7_True( void );
	INLINE_CHAINS void chain8_False( void );
	INLINE_CHAINS void chain4_t1( void );
	INLINE_CHAINS void chain3_t1( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_RegistrarParametro_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* RegistrarParametro_H */

// }}}RME
