// {{{RME classifier 'Logical View::VANT::VCTRL::VCONT::Rudder'

#ifndef Rudder_H
#define Rudder_H

#ifdef PRAGMA
#pragma interface "Rudder.h"
#endif

#include <RTSystem/VANT.h>
#include <Rudder_Protocol.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass Rudder;

#define SUPER RTActor
class Rudder_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'rudder_status'
	int rudder_status;
	// }}}RME

protected:
	// {{{RME port 'to_controller'
	Rudder_Protocol::Conjugate to_controller;
	// }}}RME

public:
	Rudder_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~Rudder_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:S1:J4359EC8D006F:request_value'
	INLINE_METHODS void transition2_request_value( const void * rtdata, Rudder_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:S1:J4359ECC301D6:go_right'
	INLINE_METHODS void transition3_go_right( const void * rtdata, Rudder_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:S1:J4359ECEF02FE:go_left'
	INLINE_METHODS void transition4_go_left( const void * rtdata, Rudder_Protocol::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:S1:J4359ED190253:go_straight'
	INLINE_METHODS void transition5_go_straight( const void * rtdata, Rudder_Protocol::Conjugate * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_request_value( void );
	INLINE_CHAINS void chain4_go_left( void );
	INLINE_CHAINS void chain3_go_right( void );
	INLINE_CHAINS void chain5_go_straight( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_Rudder_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* Rudder_H */

// }}}RME
