// {{{RME classifier 'Logical View::VANT::VSUP::VBAD::Status_Protocol'

#ifndef Status_Protocol_H
#define Status_Protocol_H

#ifdef PRAGMA
#pragma interface "Status_Protocol.h"
#endif

#include <RTSystem/VANT.h>

struct Status_Protocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum
		{
			rti_turnIdle = rtiLast_RTRootProtocol + 1
		  , rti_turnBusy
		  , rti_request
		};

	protected:
		enum { rtiLast_Status_Protocol = rti_request };

	public:
		inline RTInSignal turnIdle( void );
		inline RTInSignal turnBusy( void );
		inline RTInSignal request( void );
		inline RTOutSignal status( const bool & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum { rti_status = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Status_Protocol = rti_status };

	public:
		inline RTInSignal status( void );
		inline RTOutSignal turnIdle( const bool & data );
		inline RTOutSignal turnBusy( const bool & data );
		inline RTOutSignal request( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline Status_Protocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline Status_Protocol::Base::~Base( void )
{
}

inline RTInSignal Status_Protocol::Base::turnIdle( void )
{
	return RTInSignal( this, rti_turnIdle );
}

inline RTInSignal Status_Protocol::Base::turnBusy( void )
{
	return RTInSignal( this, rti_turnBusy );
}

inline RTInSignal Status_Protocol::Base::request( void )
{
	return RTInSignal( this, rti_request );
}

inline RTOutSignal Status_Protocol::Base::status( const bool & data )
{
	return RTOutSignal( this, Conjugate::rti_status, &data, &RTType_bool );
}

inline Status_Protocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline Status_Protocol::Conjugate::~Conjugate( void )
{
}

inline RTInSignal Status_Protocol::Conjugate::status( void )
{
	return RTInSignal( this, rti_status );
}

inline RTOutSignal Status_Protocol::Conjugate::turnIdle( const bool & data )
{
	return RTOutSignal( this, Base::rti_turnIdle, &data, &RTType_bool );
}

inline RTOutSignal Status_Protocol::Conjugate::turnBusy( const bool & data )
{
	return RTOutSignal( this, Base::rti_turnBusy, &data, &RTType_bool );
}

inline RTOutSignal Status_Protocol::Conjugate::request( void )
{
	return RTOutSignal( this, Base::rti_request, (const void *)0, &RTType_void );
}

#endif /* Status_Protocol_H */

// }}}RME
