// {{{RME classifier 'Logical View::VANT::VANT_Main'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VANT_Main.h"
#endif

#include <RTSystem/VANT.h>
#include <VANT_Main.h>
#include <COM_PROTOCOL.h>
extern const RTActorClass VANT;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"OutEC"
	  , &COM_PROTOCOL::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_VANT_Main_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VANT_Main_Actor( _rts, _ref );
}

const RTActorClass VANT_Main =
{
	(const RTActorClass *)0
  , "VANT_Main"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_VANT_Main_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_vant[] =
{
	{
		"com_to_station"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vant[] =
{
	{
		0
	  , &COM_PROTOCOL::Base::rt_class
	}
};

#define SUPER RTActor

VANT_Main_Actor::VANT_Main_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VANT_Main_Actor::~VANT_Main_Actor( void )
{
}

int VANT_Main_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// OutEC
		if( rtg_repIndex < 1 )
		{
			// vant/com_to_station
			return vant._followIn( rtg_end, 0, rtg_repIndex );
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

int VANT_Main_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// vant
		switch( rtg_portId )
		{
		case 0:
			// com_to_station
			if( rtg_repIndex < 1 )
			{
				// OutEC
				return _followOut( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void VANT_Main_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VANT_Main_Actor::getActorData( void ) const
{
	return &VANT_Main_Actor::rtg_class;
}

const RTActor_class VANT_Main_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , VANT_Main_Actor::rtg_parent_state
  , &VANT_Main
  , 1
  , VANT_Main_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId VANT_Main_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor VANT_Main_Actor::rtg_capsule_roles[] =
{
	{
		"vant"
	  , &VANT
	  , RTOffsetOf( VANT_Main_Actor, vant )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_vant
	  , 1
	  , rtg_bindings_vant
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
