// {{{RME classifier 'Logical View::VANT::VSUP::VBAD::VBAD'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VBAD.h"
#endif

#include <RTSystem/VANT.h>
#include <VBAD.h>
#include <Bus_Comb_Protocol.h>
#include <Bus_Cont_Protocol.h>
#include <Bus_Power_Protocol.h>
#include <COM_PROTOCOL.h>
#include <NAV_PROTOCOL.h>
#include <VIG_PROTOCOL.h>
#include <vcal_protocol.h>
#include <vcxp_protocol.h>
#include <vsel_protocol.h>
extern const RTActorClass VBAD_Main;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"vcal"
	  , &vcal_protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"vsel"
	  , &vsel_protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"vcxp"
	  , &vcxp_protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"bus_power_sup"
	  , &Bus_Power_Protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"bus_cont_sup"
	  , &Bus_Cont_Protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"bus_comb_sup"
	  , &Bus_Comb_Protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"nav_sup"
	  , &NAV_PROTOCOL::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"vig_sup"
	  , &VIG_PROTOCOL::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"com_sup"
	  , &COM_PROTOCOL::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_VBAD_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VBAD_Actor( _rts, _ref );
}

const RTActorClass VBAD =
{
	(const RTActorClass *)0
  , "VBAD"
  , (RTVersionId)0
  , 9
  , rtg_relays
  , new_VBAD_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_vbad[] =
{
	{
		"vcal"
	  , 1
	}
  , {
		"vcxp"
	  , 1
	}
  , {
		"vsel"
	  , 1
	}
  , {
		"bus_power_sup"
	  , 1
	}
  , {
		"bus_comb_sup"
	  , 1
	}
  , {
		"bus_cont_sup"
	  , 1
	}
  , {
		"com_sup"
	  , 1
	}
  , {
		"vig_sup"
	  , 1
	}
  , {
		"nav_sup"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vbad[] =
{
	{
		0
	  , &vcal_protocol::Base::rt_class
	}
  , {
		1
	  , &vcxp_protocol::Base::rt_class
	}
  , {
		2
	  , &vsel_protocol::Base::rt_class
	}
  , {
		3
	  , &Bus_Power_Protocol::Base::rt_class
	}
  , {
		4
	  , &Bus_Comb_Protocol::Conjugate::rt_class
	}
  , {
		5
	  , &Bus_Cont_Protocol::Conjugate::rt_class
	}
  , {
		6
	  , &COM_PROTOCOL::Base::rt_class
	}
  , {
		7
	  , &VIG_PROTOCOL::Conjugate::rt_class
	}
  , {
		8
	  , &NAV_PROTOCOL::Conjugate::rt_class
	}
};

#define SUPER RTActor

VBAD_Actor::VBAD_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VBAD_Actor::~VBAD_Actor( void )
{
}

int VBAD_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// vcal
		if( rtg_repIndex < 1 )
		{
			// vbad/vcal
			return vbad._followIn( rtg_end, 0, rtg_repIndex );
		}
		break;
	case 1:
		// vsel
		if( rtg_repIndex < 1 )
		{
			// vbad/vsel
			return vbad._followIn( rtg_end, 2, rtg_repIndex );
		}
		break;
	case 2:
		// vcxp
		if( rtg_repIndex < 1 )
		{
			// vbad/vcxp
			return vbad._followIn( rtg_end, 1, rtg_repIndex );
		}
		break;
	case 3:
		// bus_power_sup
		if( rtg_repIndex < 1 )
		{
			// vbad/bus_power_sup
			return vbad._followIn( rtg_end, 3, rtg_repIndex );
		}
		break;
	case 4:
		// bus_cont_sup
		if( rtg_repIndex < 1 )
		{
			// vbad/bus_cont_sup
			return vbad._followIn( rtg_end, 5, rtg_repIndex );
		}
		break;
	case 5:
		// bus_comb_sup
		if( rtg_repIndex < 1 )
		{
			// vbad/bus_comb_sup
			return vbad._followIn( rtg_end, 4, rtg_repIndex );
		}
		break;
	case 6:
		// nav_sup
		if( rtg_repIndex < 1 )
		{
			// vbad/nav_sup
			return vbad._followIn( rtg_end, 8, rtg_repIndex );
		}
		break;
	case 7:
		// vig_sup
		if( rtg_repIndex < 1 )
		{
			// vbad/vig_sup
			return vbad._followIn( rtg_end, 7, rtg_repIndex );
		}
		break;
	case 8:
		// com_sup
		if( rtg_repIndex < 1 )
		{
			// vbad/com_sup
			return vbad._followIn( rtg_end, 6, rtg_repIndex );
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

int VBAD_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// vbad
		switch( rtg_portId )
		{
		case 0:
			// vcal
			if( rtg_repIndex < 1 )
			{
				// vcal
				return _followOut( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// vcxp
			if( rtg_repIndex < 1 )
			{
				// vcxp
				return _followOut( rtg_end, 2, rtg_repIndex );
			}
			break;
		case 2:
			// vsel
			if( rtg_repIndex < 1 )
			{
				// vsel
				return _followOut( rtg_end, 1, rtg_repIndex );
			}
			break;
		case 3:
			// bus_power_sup
			if( rtg_repIndex < 1 )
			{
				// bus_power_sup
				return _followOut( rtg_end, 3, rtg_repIndex );
			}
			break;
		case 4:
			// bus_comb_sup
			if( rtg_repIndex < 1 )
			{
				// bus_comb_sup
				return _followOut( rtg_end, 5, rtg_repIndex );
			}
			break;
		case 5:
			// bus_cont_sup
			if( rtg_repIndex < 1 )
			{
				// bus_cont_sup
				return _followOut( rtg_end, 4, rtg_repIndex );
			}
			break;
		case 6:
			// com_sup
			if( rtg_repIndex < 1 )
			{
				// com_sup
				return _followOut( rtg_end, 8, rtg_repIndex );
			}
			break;
		case 7:
			// vig_sup
			if( rtg_repIndex < 1 )
			{
				// vig_sup
				return _followOut( rtg_end, 7, rtg_repIndex );
			}
			break;
		case 8:
			// nav_sup
			if( rtg_repIndex < 1 )
			{
				// nav_sup
				return _followOut( rtg_end, 6, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void VBAD_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VBAD_Actor::getActorData( void ) const
{
	return &VBAD_Actor::rtg_class;
}

const RTActor_class VBAD_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , VBAD_Actor::rtg_parent_state
  , &VBAD
  , 1
  , VBAD_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId VBAD_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor VBAD_Actor::rtg_capsule_roles[] =
{
	{
		"vbad"
	  , &VBAD_Main
	  , RTOffsetOf( VBAD_Actor, vbad )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 9
	  , rtg_interfaces_vbad
	  , 9
	  , rtg_bindings_vbad
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
