// {{{RME classifier 'Logical View::VANT::VSUP::VBAD::VBAD_Main'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VBAD_Main.h"
#endif

#include <RTSystem/VANT.h>
#include <VBAD_Main.h>
#include <Bus_Comb_Protocol.h>
#include <Bus_Cont_Protocol.h>
#include <Bus_Power_Protocol.h>
#include <COM_PROTOCOL.h>
#include <NAV_PROTOCOL.h>
#include <Status_Protocol.h>
#include <VBAD_PInterface.h>
#include <VIG_PROTOCOL.h>
#include <vcal_protocol.h>
#include <vcxp_protocol.h>
#include <vsel_protocol.h>
extern const RTActorClass VBAD_Interface;
extern const RTActorClass VBAD_MI;
extern const RTActorClass VBAD_RW;
extern const RTActorClass VBAD_STATUS;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"vcal"
	  , &vcal_protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"vcxp"
	  , &vcxp_protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"vsel"
	  , &vsel_protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"bus_power_sup"
	  , &Bus_Power_Protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"bus_comb_sup"
	  , &Bus_Comb_Protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"bus_cont_sup"
	  , &Bus_Cont_Protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"com_sup"
	  , &COM_PROTOCOL::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"vig_sup"
	  , &VIG_PROTOCOL::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"nav_sup"
	  , &NAV_PROTOCOL::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_VBAD_Main_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VBAD_Main_Actor( _rts, _ref );
}

const RTActorClass VBAD_Main =
{
	(const RTActorClass *)0
  , "VBAD_Main"
  , (RTVersionId)0
  , 9
  , rtg_relays
  , new_VBAD_Main_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_vbad_interface[] =
{
	{
		"interface_mi"
	  , 1
	}
  , {
		"interface_status"
	  , 1
	}
  , {
		"interface_rw"
	  , 1
	}
  , {
		"vbad_vcal"
	  , 1
	}
  , {
		"vbad_vcxp"
	  , 1
	}
  , {
		"vbad_vsel"
	  , 1
	}
  , {
		"bus_power_control"
	  , 1
	}
  , {
		"bus_cont_sup"
	  , 1
	}
  , {
		"bus_comb_sup"
	  , 1
	}
  , {
		"nav_sup"
	  , 1
	}
  , {
		"vig_sup"
	  , 1
	}
  , {
		"com_sup"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vbad_interface[] =
{
	{
		0
	  , &VBAD_PInterface::Conjugate::rt_class
	}
  , {
		1
	  , &VBAD_PInterface::Base::rt_class
	}
  , {
		2
	  , &VBAD_PInterface::Conjugate::rt_class
	}
  , {
		3
	  , &vcal_protocol::Base::rt_class
	}
  , {
		4
	  , &vcxp_protocol::Base::rt_class
	}
  , {
		5
	  , &vsel_protocol::Base::rt_class
	}
  , {
		6
	  , &Bus_Power_Protocol::Base::rt_class
	}
  , {
		7
	  , &Bus_Cont_Protocol::Conjugate::rt_class
	}
  , {
		8
	  , &Bus_Comb_Protocol::Conjugate::rt_class
	}
  , {
		9
	  , &NAV_PROTOCOL::Conjugate::rt_class
	}
  , {
		10
	  , &VIG_PROTOCOL::Conjugate::rt_class
	}
  , {
		11
	  , &COM_PROTOCOL::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_vbad_mi[] =
{
	{
		"mi_port"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vbad_mi[] =
{
	{
		0
	  , &VBAD_PInterface::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_vbad_rw[] =
{
	{
		"rw_port"
	  , 1
	}
  , {
		"status"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vbad_rw[] =
{
	{
		0
	  , &VBAD_PInterface::Base::rt_class
	}
  , {
		1
	  , &Status_Protocol::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_vbad_status[] =
{
	{
		"status_port"
	  , 1
	}
  , {
		"status_internal"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vbad_status[] =
{
	{
		0
	  , &VBAD_PInterface::Conjugate::rt_class
	}
  , {
		1
	  , &Status_Protocol::Conjugate::rt_class
	}
};

#define SUPER RTActor

VBAD_Main_Actor::VBAD_Main_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VBAD_Main_Actor::~VBAD_Main_Actor( void )
{
}

int VBAD_Main_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// vcal
		if( rtg_repIndex < 1 )
		{
			// vbad_interface/vbad_vcal
			return vbad_interface._followIn( rtg_end, 3, rtg_repIndex );
		}
		break;
	case 1:
		// vcxp
		if( rtg_repIndex < 1 )
		{
			// vbad_interface/vbad_vcxp
			return vbad_interface._followIn( rtg_end, 4, rtg_repIndex );
		}
		break;
	case 2:
		// vsel
		if( rtg_repIndex < 1 )
		{
			// vbad_interface/vbad_vsel
			return vbad_interface._followIn( rtg_end, 5, rtg_repIndex );
		}
		break;
	case 3:
		// bus_power_sup
		if( rtg_repIndex < 1 )
		{
			// vbad_interface/bus_power_control
			return vbad_interface._followIn( rtg_end, 6, rtg_repIndex );
		}
		break;
	case 4:
		// bus_comb_sup
		if( rtg_repIndex < 1 )
		{
			// vbad_interface/bus_comb_sup
			return vbad_interface._followIn( rtg_end, 8, rtg_repIndex );
		}
		break;
	case 5:
		// bus_cont_sup
		if( rtg_repIndex < 1 )
		{
			// vbad_interface/bus_cont_sup
			return vbad_interface._followIn( rtg_end, 7, rtg_repIndex );
		}
		break;
	case 6:
		// com_sup
		if( rtg_repIndex < 1 )
		{
			// vbad_interface/com_sup
			return vbad_interface._followIn( rtg_end, 11, rtg_repIndex );
		}
		break;
	case 7:
		// vig_sup
		if( rtg_repIndex < 1 )
		{
			// vbad_interface/vig_sup
			return vbad_interface._followIn( rtg_end, 10, rtg_repIndex );
		}
		break;
	case 8:
		// nav_sup
		if( rtg_repIndex < 1 )
		{
			// vbad_interface/nav_sup
			return vbad_interface._followIn( rtg_end, 9, rtg_repIndex );
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

int VBAD_Main_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// vbad_interface
		switch( rtg_portId )
		{
		case 0:
			// interface_mi
			if( rtg_repIndex < 1 )
			{
				// vbad_mi/mi_port
				return vbad_mi._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// interface_status
			if( rtg_repIndex < 1 )
			{
				// vbad_status/status_port
				return vbad_status._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 2:
			// interface_rw
			if( rtg_repIndex < 1 )
			{
				// vbad_rw/rw_port
				return vbad_rw._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 3:
			// vbad_vcal
			if( rtg_repIndex < 1 )
			{
				// vcal
				return _followOut( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 4:
			// vbad_vcxp
			if( rtg_repIndex < 1 )
			{
				// vcxp
				return _followOut( rtg_end, 1, rtg_repIndex );
			}
			break;
		case 5:
			// vbad_vsel
			if( rtg_repIndex < 1 )
			{
				// vsel
				return _followOut( rtg_end, 2, rtg_repIndex );
			}
			break;
		case 6:
			// bus_power_control
			if( rtg_repIndex < 1 )
			{
				// bus_power_sup
				return _followOut( rtg_end, 3, rtg_repIndex );
			}
			break;
		case 7:
			// bus_cont_sup
			if( rtg_repIndex < 1 )
			{
				// bus_cont_sup
				return _followOut( rtg_end, 5, rtg_repIndex );
			}
			break;
		case 8:
			// bus_comb_sup
			if( rtg_repIndex < 1 )
			{
				// bus_comb_sup
				return _followOut( rtg_end, 4, rtg_repIndex );
			}
			break;
		case 9:
			// nav_sup
			if( rtg_repIndex < 1 )
			{
				// nav_sup
				return _followOut( rtg_end, 8, rtg_repIndex );
			}
			break;
		case 10:
			// vig_sup
			if( rtg_repIndex < 1 )
			{
				// vig_sup
				return _followOut( rtg_end, 7, rtg_repIndex );
			}
			break;
		case 11:
			// com_sup
			if( rtg_repIndex < 1 )
			{
				// com_sup
				return _followOut( rtg_end, 6, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 2:
		// vbad_mi
		switch( rtg_portId )
		{
		case 0:
			// mi_port
			if( rtg_repIndex < 1 )
			{
				// vbad_interface/interface_mi
				return vbad_interface._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 3:
		// vbad_rw
		switch( rtg_portId )
		{
		case 0:
			// rw_port
			if( rtg_repIndex < 1 )
			{
				// vbad_interface/interface_rw
				return vbad_interface._followIn( rtg_end, 2, rtg_repIndex );
			}
			break;
		case 1:
			// status
			if( rtg_repIndex < 1 )
			{
				// vbad_status/status_internal
				return vbad_status._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 4:
		// vbad_status
		switch( rtg_portId )
		{
		case 0:
			// status_port
			if( rtg_repIndex < 1 )
			{
				// vbad_interface/interface_status
				return vbad_interface._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		case 1:
			// status_internal
			if( rtg_repIndex < 1 )
			{
				// vbad_rw/status
				return vbad_rw._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void VBAD_Main_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VBAD_Main_Actor::getActorData( void ) const
{
	return &VBAD_Main_Actor::rtg_class;
}

const RTActor_class VBAD_Main_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , VBAD_Main_Actor::rtg_parent_state
  , &VBAD_Main
  , 4
  , VBAD_Main_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId VBAD_Main_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor VBAD_Main_Actor::rtg_capsule_roles[] =
{
	{
		"vbad_interface"
	  , &VBAD_Interface
	  , RTOffsetOf( VBAD_Main_Actor, vbad_interface )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 12
	  , rtg_interfaces_vbad_interface
	  , 12
	  , rtg_bindings_vbad_interface
	}
  , {
		"vbad_mi"
	  , &VBAD_MI
	  , RTOffsetOf( VBAD_Main_Actor, vbad_mi )
	  , 2
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_vbad_mi
	  , 1
	  , rtg_bindings_vbad_mi
	}
  , {
		"vbad_rw"
	  , &VBAD_RW
	  , RTOffsetOf( VBAD_Main_Actor, vbad_rw )
	  , 3
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 2
	  , rtg_interfaces_vbad_rw
	  , 2
	  , rtg_bindings_vbad_rw
	}
  , {
		"vbad_status"
	  , &VBAD_STATUS
	  , RTOffsetOf( VBAD_Main_Actor, vbad_status )
	  , 4
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 2
	  , rtg_interfaces_vbad_status
	  , 2
	  , rtg_bindings_vbad_status
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
