// {{{RME classifier 'Logical View::VANT::VSUP::VBAD::VBAD_PInterface'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VBAD_PInterface.h"
#endif

#include <RTSystem/VANT.h>
#include <VBAD_PInterface.h>

const RTProtocolDescriptor VBAD_PInterface::Base::rt_class =
{
	&PMission::Base::rt_class
  , &VBAD_PInterface::Conjugate::rt_class
  , "VBAD_PInterface"
  , 0
  , 4
  , VBAD_PInterface::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor VBAD_PInterface::Base::rt_signals[] =
{
	{
		"requestMission"
	  , &RTType_MissionVant
	  , VBAD_PInterface::Base::rti_requestMission
	}
  , {
		"returnContext"
	  , &RTType_void
	  , VBAD_PInterface::Base::rti_returnContext
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , VBAD_PInterface::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , VBAD_PInterface::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor VBAD_PInterface::Conjugate::rt_class =
{
	&PMission::Conjugate::rt_class
  , &VBAD_PInterface::Base::rt_class
  , "VBAD_PInterface"
  , 0
  , 7
  , VBAD_PInterface::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor VBAD_PInterface::Conjugate::rt_signals[] =
{
	{
		"activeMI"
	  , &RTType_void
	  , VBAD_PInterface::Conjugate::rti_activeMI
	}
  , {
		"activeRead"
	  , &RTType_char
	  , VBAD_PInterface::Conjugate::rti_activeRead
	}
  , {
		"activeSTA"
	  , &RTType_void
	  , VBAD_PInterface::Conjugate::rti_activeSTA
	}
  , {
		"activeWrite"
	  , &RTType_char
	  , VBAD_PInterface::Conjugate::rti_activeWrite
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , VBAD_PInterface::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , VBAD_PInterface::Conjugate::rti_rtUnbound
	}
  , {
		"sendMission"
	  , &RTType_MissionVant
	  , VBAD_PInterface::Conjugate::rti_sendMission
	}
};

// }}}RME
