// {{{RME classifier 'Logical View::VANT::VSUP::VBAD::VBAD_PInterface'

#ifndef VBAD_PInterface_H
#define VBAD_PInterface_H

#ifdef PRAGMA
#pragma interface "VBAD_PInterface.h"
#endif

#include <RTSystem/VANT.h>
#include <PMission.h>

struct VBAD_PInterface
{
	class Base : public PMission::Base
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_returnContext = rtiLast_PMission + 1 };

	protected:
		enum { rtiLast_VBAD_PInterface = rti_returnContext };

	public:
		inline RTInSignal returnContext( void );
		inline RTOutSignal activeMI( void );
		inline RTOutSignal activeSTA( void );
		inline RTOutSignal activeRead( const char & data );
		inline RTOutSignal activeWrite( const char & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public PMission::Conjugate
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_activeMI = rtiLast_PMission + 1
		  , rti_activeSTA
		  , rti_activeRead
		  , rti_activeWrite
		};

	protected:
		enum { rtiLast_VBAD_PInterface = rti_activeWrite };

	public:
		inline RTInSignal activeMI( void );
		inline RTInSignal activeSTA( void );
		inline RTInSignal activeRead( void );
		inline RTInSignal activeWrite( void );
		inline RTOutSignal returnContext( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline VBAD_PInterface::Base::Base( void )
	: PMission::Base()
{
}

inline VBAD_PInterface::Base::~Base( void )
{
}

inline RTInSignal VBAD_PInterface::Base::returnContext( void )
{
	return RTInSignal( this, rti_returnContext );
}

inline RTOutSignal VBAD_PInterface::Base::activeMI( void )
{
	return RTOutSignal( this, Conjugate::rti_activeMI, (const void *)0, &RTType_void );
}

inline RTOutSignal VBAD_PInterface::Base::activeSTA( void )
{
	return RTOutSignal( this, Conjugate::rti_activeSTA, (const void *)0, &RTType_void );
}

inline RTOutSignal VBAD_PInterface::Base::activeRead( const char & data )
{
	return RTOutSignal( this, Conjugate::rti_activeRead, &data, &RTType_char );
}

inline RTOutSignal VBAD_PInterface::Base::activeWrite( const char & data )
{
	return RTOutSignal( this, Conjugate::rti_activeWrite, &data, &RTType_char );
}

inline VBAD_PInterface::Conjugate::Conjugate( void )
	: PMission::Conjugate()
{
}

inline VBAD_PInterface::Conjugate::~Conjugate( void )
{
}

inline RTInSignal VBAD_PInterface::Conjugate::activeMI( void )
{
	return RTInSignal( this, rti_activeMI );
}

inline RTInSignal VBAD_PInterface::Conjugate::activeSTA( void )
{
	return RTInSignal( this, rti_activeSTA );
}

inline RTInSignal VBAD_PInterface::Conjugate::activeRead( void )
{
	return RTInSignal( this, rti_activeRead );
}

inline RTInSignal VBAD_PInterface::Conjugate::activeWrite( void )
{
	return RTInSignal( this, rti_activeWrite );
}

inline RTOutSignal VBAD_PInterface::Conjugate::returnContext( void )
{
	return RTOutSignal( this, Base::rti_returnContext, (const void *)0, &RTType_void );
}

#endif /* VBAD_PInterface_H */

// }}}RME
