// {{{RME classifier 'Logical View::VANT::VSUP::VBAD::VBAD_RW'

#ifndef VBAD_RW_H
#define VBAD_RW_H

#ifdef PRAGMA
#pragma interface "VBAD_RW.h"
#endif

#include <RTSystem/VANT.h>
#include <Status_Protocol.h>
#include <VBAD_PInterface.h>
class MissionVant;

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
#include <stdio.h>
// }}}USR
// }}}RME

extern const RTActorClass VBAD_RW;

#define SUPER RTActor
class VBAD_RW_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'charDataRW'
	char charDataRW;
	// }}}RME

protected:
	// {{{RME port 'rw_port'
	VBAD_PInterface::Conjugate rw_port;
	// }}}RME
	// {{{RME port 'myTimer'
	Timing::Base myTimer;
	// }}}RME
	// {{{RME port 'status'
	Status_Protocol::Conjugate status;
	// }}}RME

public:
	VBAD_RW_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~VBAD_RW_Actor( void );

protected:
	// {{{RME operation 'readData()'
	void readData( void );
	// }}}RME
	// {{{RME operation 'writeData(char)'
	void writeData( char cWrite );
	// }}}RME

public:
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME enter ':TOP:READ'
	INLINE_METHODS void enter3_READ( void );
	// }}}RME
	virtual void enterStateV( void );
	// {{{RME enter ':TOP:WRITE'
	INLINE_METHODS void enter4_WRITE( void );
	// }}}RME
	// {{{RME exit ':TOP:READ'
	INLINE_METHODS void exit3_READ( void );
	// }}}RME
	virtual void exitStateV( void );
	// {{{RME exit ':TOP:WRITE'
	INLINE_METHODS void exit4_WRITE( void );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J434FD3FA00DB:t_read'
	INLINE_METHODS void transition2_t_read( const char * rtdata, VBAD_PInterface::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J434FD41900AB:t_write'
	INLINE_METHODS void transition3_t_write( const char * rtdata, VBAD_PInterface::Conjugate * rtport );
	// }}}RME
	// {{{RME transition ':TOP:READ:J434FD43A0243:t_return_read'
	INLINE_METHODS void transition4_t_return_read( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:WRITE:J434FD44D038B:t_return_write'
	INLINE_METHODS void transition5_t_return_write( const void * rtdata, Timing::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_t_read( void );
	INLINE_CHAINS void chain3_t_write( void );
	INLINE_CHAINS void chain4_t_return_read( void );
	INLINE_CHAINS void chain5_t_return_write( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_VBAD_RW_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* VBAD_RW_H */

// }}}RME
