// {{{RME classifier 'Logical View::VANT::VCNS::VCOM::VCOM_Controller'

#ifndef VCOM_Controller_H
#define VCOM_Controller_H

#ifdef PRAGMA
#pragma interface "VCOM_Controller.h"
#endif

#include <RTSystem/VANT.h>
#include <COM_PROTOCOL.h>
class MissionVant;

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
#include <stdio.h>
// }}}USR
// }}}RME

extern const RTActorClass VCOM_Controller;

#define SUPER RTActor
class VCOM_Controller_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'intMission'
	int intMission;
	// }}}RME

protected:
	// {{{RME port 'to_sat'
	COM_PROTOCOL::Base to_sat;
	// }}}RME
	// {{{RME port 'to_bus'
	COM_PROTOCOL::Base to_bus;
	// }}}RME
	// {{{RME port 'to_station'
	COM_PROTOCOL::Conjugate to_station;
	// }}}RME

public:
	VCOM_Controller_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~VCOM_Controller_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Waiting:J436F577C039B:fuel_level'
	INLINE_METHODS void transition2_fuel_level( const int * rtdata, COM_PROTOCOL::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F59470204:speed_value'
	INLINE_METHODS void transition3_speed_value( const int * rtdata, COM_PROTOCOL::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F5FEE02DE:position_value'
	INLINE_METHODS void transition4_position_value( const Coordinate * rtdata, COM_PROTOCOL::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F8361015B:traj_data'
	INLINE_METHODS void transition5_traj_data( const int * rtdata, COM_PROTOCOL::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F83F500FC:image_data'
	INLINE_METHODS void transition6_image_data( const rgb * rtdata, COM_PROTOCOL::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F84330267:alarm_data'
	INLINE_METHODS void transition7_alarm_data( const int * rtdata, COM_PROTOCOL::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F848300E6:flight_data'
	INLINE_METHODS void transition8_flight_data( const int * rtdata, COM_PROTOCOL::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F869701AC:req_fuel_lv'
	INLINE_METHODS void transition9_req_fuel_lv( const int * rtdata, COM_PROTOCOL::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F87180049:req_traj_dt'
	INLINE_METHODS void transition10_req_traj_dt( const int * rtdata, COM_PROTOCOL::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F889501D9:req_posit_vl'
	INLINE_METHODS void transition11_req_posit_vl( const Coordinate * rtdata, COM_PROTOCOL::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F89F10002:req_speed_vl'
	INLINE_METHODS void transition12_req_speed_vl( const int * rtdata, COM_PROTOCOL::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F8ABF0290:req_image_dt'
	INLINE_METHODS void transition13_req_image_dt( const rgb * rtdata, COM_PROTOCOL::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F8AFA0377:req_flight_dt'
	INLINE_METHODS void transition14_req_flight_dt( const int * rtdata, COM_PROTOCOL::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F8B3D03C6:final_posit'
	INLINE_METHODS void transition15_final_posit( const Coordinate * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F8B9D0089:mission_speed'
	INLINE_METHODS void transition16_mission_speed( const int * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J436F8CA402D8:mission_time'
	INLINE_METHODS void transition17_mission_time( const int * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Waiting:J437F88B400DC:AcknownledgmentMission'
	INLINE_METHODS void transition18_AcknownledgmentMission( const MissionVant * rtdata, COM_PROTOCOL::Conjugate * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain9_req_fuel_lv( void );
	INLINE_CHAINS void chain10_req_traj_dt( void );
	INLINE_CHAINS void chain11_req_posit_vl( void );
	INLINE_CHAINS void chain12_req_speed_vl( void );
	INLINE_CHAINS void chain13_req_image_dt( void );
	INLINE_CHAINS void chain14_req_flight_dt( void );
	INLINE_CHAINS void chain16_mission_speed( void );
	INLINE_CHAINS void chain17_mission_time( void );
	INLINE_CHAINS void chain15_final_posit( void );
	INLINE_CHAINS void chain2_fuel_level( void );
	INLINE_CHAINS void chain5_traj_data( void );
	INLINE_CHAINS void chain4_position_value( void );
	INLINE_CHAINS void chain3_speed_value( void );
	INLINE_CHAINS void chain6_image_data( void );
	INLINE_CHAINS void chain7_alarm_data( void );
	INLINE_CHAINS void chain8_flight_data( void );
	INLINE_CHAINS void chain18_AcknownledgmentMission( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_VCOM_Controller_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* VCOM_Controller_H */

// }}}RME
