// {{{RME classifier 'Logical View::VANT::VSUP::VSEL::VSEL_ARMAZENAMENTO'

#ifndef VSEL_ARMAZENAMENTO_H
#define VSEL_ARMAZENAMENTO_H

#ifdef PRAGMA
#pragma interface "VSEL_ARMAZENAMENTO.h"
#endif

#include <RTSystem/VANT.h>
#include <vsel_protocol.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
#include <stdio.h>
// }}}USR
// }}}RME

extern const RTActorClass VSEL_ARMAZENAMENTO;

#define SUPER RTActor
class VSEL_ARMAZENAMENTO_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME
	// {{{RME classAttribute 'status'
	bool status;
	// }}}RME
	// {{{RME classAttribute 'MINCARGA'
	const int MINCARGA;
	// }}}RME

protected:
	// {{{RME port 'vsel_interface'
	vsel_protocol::Base vsel_interface;
	// }}}RME
	// {{{RME port 'timer'
	Timing::Base timer;
	// }}}RME
	// {{{RME port 'vsel_internal'
	vsel_protocol::Base vsel_internal;
	// }}}RME

public:
	VSEL_ARMAZENAMENTO_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~VSEL_ARMAZENAMENTO_Actor( void );

protected:
	// {{{RME operation 'VerificarCarga(int)'
	void VerificarCarga( int parCarga );
	// }}}RME
	// {{{RME operation 'EnviarAlarme()'
	void EnviarAlarme( void );
	// }}}RME

public:
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Initial:Initial'
	INLINE_METHODS void transition1_Initial( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:waiting:J43539E990197:verifyCharge'
	INLINE_METHODS void transition2_verifyCharge( const int * rtdata, vsel_protocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:verify:J43539EAE03BF:timeout'
	INLINE_METHODS void transition3_timeout( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:lowBattery:True'
	INLINE_METHODS void transition4_True( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:lowBattery:False'
	INLINE_METHODS void transition5_False( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:sendAlarm:J43539EBF03AB:timeout'
	INLINE_METHODS void transition6_timeout( const void * rtdata, Timing::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_verifyCharge( void );
	INLINE_CHAINS void chain3_timeout( void );

protected:
	// {{{RME choicePoint ':TOP:lowBattery'
	INLINE_METHODS int choicePoint1_lowBattery( const void * rtdata, Timing::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain4_True( void );
	INLINE_CHAINS void chain5_False( void );
	INLINE_CHAINS void chain6_timeout( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_VSEL_ARMAZENAMENTO_fields[];
};
#undef SUPER

// {{{RME classAttribute 'intCarga'
extern int intCarga;
// }}}RME

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* VSEL_ARMAZENAMENTO_H */

// }}}RME
