// {{{RME classifier 'Logical View::VANT::VSUP::VSUP_CSC'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VSUP_CSC.h"
#endif

#include <RTSystem/VANT.h>
#include <VSUP_CSC.h>
#include <Bus_Comb_Protocol.h>
#include <Bus_Cont_Protocol.h>
#include <Bus_Power_Protocol.h>
#include <COM_PROTOCOL.h>
#include <NAV_PROTOCOL.h>
#include <VIG_PROTOCOL.h>
#include <vcal_protocol.h>
#include <vcxp_protocol.h>
#include <vsel_protocol.h>
extern const RTActorClass VBAD;
extern const RTActorClass VCAL_MEAM;
extern const RTActorClass VCXP;
extern const RTActorClass VSEL;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"bus_power_sup"
	  , &Bus_Power_Protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"bus_comb_sup"
	  , &Bus_Comb_Protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"bus_cont_sup"
	  , &Bus_Cont_Protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"com_sup"
	  , &COM_PROTOCOL::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"vig_sup"
	  , &VIG_PROTOCOL::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"nav_sup"
	  , &NAV_PROTOCOL::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_VSUP_CSC_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VSUP_CSC_Actor( _rts, _ref );
}

const RTActorClass VSUP_CSC =
{
	(const RTActorClass *)0
  , "VSUP_CSC"
  , (RTVersionId)0
  , 6
  , rtg_relays
  , new_VSUP_CSC_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_vcal[] =
{
	{
		"vcal_interface"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vcal[] =
{
	{
		0
	  , &vcal_protocol::Conjugate::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_vbad[] =
{
	{
		"vcal"
	  , 1
	}
  , {
		"vsel"
	  , 1
	}
  , {
		"vcxp"
	  , 1
	}
  , {
		"bus_power_sup"
	  , 1
	}
  , {
		"bus_cont_sup"
	  , 1
	}
  , {
		"bus_comb_sup"
	  , 1
	}
  , {
		"nav_sup"
	  , 1
	}
  , {
		"vig_sup"
	  , 1
	}
  , {
		"com_sup"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vbad[] =
{
	{
		0
	  , &vcal_protocol::Base::rt_class
	}
  , {
		1
	  , &vsel_protocol::Base::rt_class
	}
  , {
		2
	  , &vcxp_protocol::Base::rt_class
	}
  , {
		3
	  , &Bus_Power_Protocol::Base::rt_class
	}
  , {
		4
	  , &Bus_Cont_Protocol::Conjugate::rt_class
	}
  , {
		5
	  , &Bus_Comb_Protocol::Conjugate::rt_class
	}
  , {
		6
	  , &NAV_PROTOCOL::Conjugate::rt_class
	}
  , {
		7
	  , &VIG_PROTOCOL::Conjugate::rt_class
	}
  , {
		8
	  , &COM_PROTOCOL::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_vcxp[] =
{
	{
		"vcxp_interface"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vcxp[] =
{
	{
		0
	  , &vcxp_protocol::Conjugate::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_vsel[] =
{
	{
		"vsel_interface"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_vsel[] =
{
	{
		0
	  , &vsel_protocol::Conjugate::rt_class
	}
};

#define SUPER RTActor

VSUP_CSC_Actor::VSUP_CSC_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VSUP_CSC_Actor::~VSUP_CSC_Actor( void )
{
}

int VSUP_CSC_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// bus_power_sup
		if( rtg_repIndex < 1 )
		{
			// vbad/bus_power_sup
			return vbad._followIn( rtg_end, 3, rtg_repIndex );
		}
		break;
	case 1:
		// bus_comb_sup
		if( rtg_repIndex < 1 )
		{
			// vbad/bus_comb_sup
			return vbad._followIn( rtg_end, 5, rtg_repIndex );
		}
		break;
	case 2:
		// bus_cont_sup
		if( rtg_repIndex < 1 )
		{
			// vbad/bus_cont_sup
			return vbad._followIn( rtg_end, 4, rtg_repIndex );
		}
		break;
	case 3:
		// com_sup
		if( rtg_repIndex < 1 )
		{
			// vbad/com_sup
			return vbad._followIn( rtg_end, 8, rtg_repIndex );
		}
		break;
	case 4:
		// vig_sup
		if( rtg_repIndex < 1 )
		{
			// vbad/vig_sup
			return vbad._followIn( rtg_end, 7, rtg_repIndex );
		}
		break;
	case 5:
		// nav_sup
		if( rtg_repIndex < 1 )
		{
			// vbad/nav_sup
			return vbad._followIn( rtg_end, 6, rtg_repIndex );
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

int VSUP_CSC_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// vcal
		switch( rtg_portId )
		{
		case 0:
			// vcal_interface
			if( rtg_repIndex < 1 )
			{
				// vbad/vcal
				return vbad._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 2:
		// vbad
		switch( rtg_portId )
		{
		case 0:
			// vcal
			if( rtg_repIndex < 1 )
			{
				// vcal/vcal_interface
				return vcal._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// vsel
			if( rtg_repIndex < 1 )
			{
				// vsel/vsel_interface
				return vsel._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 2:
			// vcxp
			if( rtg_repIndex < 1 )
			{
				// vcxp/vcxp_interface
				return vcxp._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 3:
			// bus_power_sup
			if( rtg_repIndex < 1 )
			{
				// bus_power_sup
				return _followOut( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 4:
			// bus_cont_sup
			if( rtg_repIndex < 1 )
			{
				// bus_cont_sup
				return _followOut( rtg_end, 2, rtg_repIndex );
			}
			break;
		case 5:
			// bus_comb_sup
			if( rtg_repIndex < 1 )
			{
				// bus_comb_sup
				return _followOut( rtg_end, 1, rtg_repIndex );
			}
			break;
		case 6:
			// nav_sup
			if( rtg_repIndex < 1 )
			{
				// nav_sup
				return _followOut( rtg_end, 5, rtg_repIndex );
			}
			break;
		case 7:
			// vig_sup
			if( rtg_repIndex < 1 )
			{
				// vig_sup
				return _followOut( rtg_end, 4, rtg_repIndex );
			}
			break;
		case 8:
			// com_sup
			if( rtg_repIndex < 1 )
			{
				// com_sup
				return _followOut( rtg_end, 3, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 3:
		// vcxp
		switch( rtg_portId )
		{
		case 0:
			// vcxp_interface
			if( rtg_repIndex < 1 )
			{
				// vbad/vcxp
				return vbad._followIn( rtg_end, 2, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 4:
		// vsel
		switch( rtg_portId )
		{
		case 0:
			// vsel_interface
			if( rtg_repIndex < 1 )
			{
				// vbad/vsel
				return vbad._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void VSUP_CSC_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VSUP_CSC_Actor::getActorData( void ) const
{
	return &VSUP_CSC_Actor::rtg_class;
}

const RTActor_class VSUP_CSC_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , VSUP_CSC_Actor::rtg_parent_state
  , &VSUP_CSC
  , 4
  , VSUP_CSC_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId VSUP_CSC_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor VSUP_CSC_Actor::rtg_capsule_roles[] =
{
	{
		"vcal"
	  , &VCAL_MEAM
	  , RTOffsetOf( VSUP_CSC_Actor, vcal )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_vcal
	  , 1
	  , rtg_bindings_vcal
	}
  , {
		"vbad"
	  , &VBAD
	  , RTOffsetOf( VSUP_CSC_Actor, vbad )
	  , 2
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 9
	  , rtg_interfaces_vbad
	  , 9
	  , rtg_bindings_vbad
	}
  , {
		"vcxp"
	  , &VCXP
	  , RTOffsetOf( VSUP_CSC_Actor, vcxp )
	  , 3
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_vcxp
	  , 1
	  , rtg_bindings_vcxp
	}
  , {
		"vsel"
	  , &VSEL
	  , RTOffsetOf( VSUP_CSC_Actor, vsel )
	  , 4
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_vsel
	  , 1
	  , rtg_bindings_vsel
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
