// {{{RME classifier 'Logical View::VANT::VCNS::VVIG::cap_VVIG'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "cap_VVIG.h"
#endif

#include <RTSystem/VANT.h>
#include <cap_VVIG.h>
#include <Image_Classifier_Protocol.h>
#include <Image_Device_Protocol.h>
#include <Image_Processor_Protocol.h>
#include <VIG_PROTOCOL.h>
extern const RTActorClass Image_Classifier;
extern const RTActorClass Image_Controller;
extern const RTActorClass Image_Device;
extern const RTActorClass Image_Processor;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"to_intbus"
	  , &VIG_PROTOCOL::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_cap_VVIG_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new cap_VVIG_Actor( _rts, _ref );
}

const RTActorClass cap_VVIG =
{
	(const RTActorClass *)0
  , "cap_VVIG"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_cap_VVIG_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_image_Controller[] =
{
	{
		"to_intbus"
	  , 1
	}
  , {
		"to_Image_Device"
	  , 1
	}
  , {
		"to_Image_Processor"
	  , 1
	}
  , {
		"to_Image_Classifier"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_image_Controller[] =
{
	{
		0
	  , &VIG_PROTOCOL::Base::rt_class
	}
  , {
		1
	  , &Image_Device_Protocol::Conjugate::rt_class
	}
  , {
		2
	  , &Image_Processor_Protocol::Conjugate::rt_class
	}
  , {
		3
	  , &Image_Classifier_Protocol::Conjugate::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_image_Device[] =
{
	{
		"to_controller"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_image_Device[] =
{
	{
		0
	  , &Image_Device_Protocol::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_image_Processor[] =
{
	{
		"to_controller"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_image_Processor[] =
{
	{
		0
	  , &Image_Processor_Protocol::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_image_Classifier[] =
{
	{
		"to_controller"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_image_Classifier[] =
{
	{
		0
	  , &Image_Classifier_Protocol::Base::rt_class
	}
};

#define SUPER RTActor

cap_VVIG_Actor::cap_VVIG_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

cap_VVIG_Actor::~cap_VVIG_Actor( void )
{
}

int cap_VVIG_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// to_intbus
		if( rtg_repIndex < 1 )
		{
			// image_Controller/to_intbus
			return image_Controller._followIn( rtg_end, 0, rtg_repIndex );
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

int cap_VVIG_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// image_Controller
		switch( rtg_portId )
		{
		case 0:
			// to_intbus
			if( rtg_repIndex < 1 )
			{
				// to_intbus
				return _followOut( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// to_Image_Device
			if( rtg_repIndex < 1 )
			{
				// image_Device/to_controller
				return image_Device._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 2:
			// to_Image_Processor
			if( rtg_repIndex < 1 )
			{
				// image_Processor/to_controller
				return image_Processor._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 3:
			// to_Image_Classifier
			if( rtg_repIndex < 1 )
			{
				// image_Classifier/to_controller
				return image_Classifier._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 2:
		// image_Device
		switch( rtg_portId )
		{
		case 0:
			// to_controller
			if( rtg_repIndex < 1 )
			{
				// image_Controller/to_Image_Device
				return image_Controller._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 3:
		// image_Processor
		switch( rtg_portId )
		{
		case 0:
			// to_controller
			if( rtg_repIndex < 1 )
			{
				// image_Controller/to_Image_Processor
				return image_Controller._followIn( rtg_end, 2, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 4:
		// image_Classifier
		switch( rtg_portId )
		{
		case 0:
			// to_controller
			if( rtg_repIndex < 1 )
			{
				// image_Controller/to_Image_Classifier
				return image_Controller._followIn( rtg_end, 3, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void cap_VVIG_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * cap_VVIG_Actor::getActorData( void ) const
{
	return &cap_VVIG_Actor::rtg_class;
}

const RTActor_class cap_VVIG_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , cap_VVIG_Actor::rtg_parent_state
  , &cap_VVIG
  , 4
  , cap_VVIG_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId cap_VVIG_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor cap_VVIG_Actor::rtg_capsule_roles[] =
{
	{
		"image_Controller"
	  , &Image_Controller
	  , RTOffsetOf( cap_VVIG_Actor, image_Controller )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 4
	  , rtg_interfaces_image_Controller
	  , 4
	  , rtg_bindings_image_Controller
	}
  , {
		"image_Device"
	  , &Image_Device
	  , RTOffsetOf( cap_VVIG_Actor, image_Device )
	  , 2
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_image_Device
	  , 1
	  , rtg_bindings_image_Device
	}
  , {
		"image_Processor"
	  , &Image_Processor
	  , RTOffsetOf( cap_VVIG_Actor, image_Processor )
	  , 3
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_image_Processor
	  , 1
	  , rtg_bindings_image_Processor
	}
  , {
		"image_Classifier"
	  , &Image_Classifier
	  , RTOffsetOf( cap_VVIG_Actor, image_Classifier )
	  , 4
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_image_Classifier
	  , 1
	  , rtg_bindings_image_Classifier
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
