// {{{RME classifier 'Logical View::VANT::VSUP::Common_VSUP::vbad_inheritance'

#ifndef vbad_inheritance_H
#define vbad_inheritance_H

#ifdef PRAGMA
#pragma interface "vbad_inheritance.h"
#endif

#include <RTSystem/VANT.h>

struct vbad_inheritance
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );

	protected:
		enum { rtiLast_vbad_inheritance = rtiLast_RTRootProtocol };

	public:
		inline RTOutSignal read( const char & data );
		inline RTOutSignal write( const char & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_read = rtiLast_RTRootProtocol + 1
		  , rti_write
		};

	protected:
		enum { rtiLast_vbad_inheritance = rti_write };

	public:
		inline RTInSignal read( void );
		inline RTInSignal write( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline vbad_inheritance::Base::Base( void )
	: RTRootProtocol()
{
}

inline vbad_inheritance::Base::~Base( void )
{
}

inline RTOutSignal vbad_inheritance::Base::read( const char & data )
{
	return RTOutSignal( this, Conjugate::rti_read, &data, &RTType_char );
}

inline RTOutSignal vbad_inheritance::Base::write( const char & data )
{
	return RTOutSignal( this, Conjugate::rti_write, &data, &RTType_char );
}

inline vbad_inheritance::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline vbad_inheritance::Conjugate::~Conjugate( void )
{
}

inline RTInSignal vbad_inheritance::Conjugate::read( void )
{
	return RTInSignal( this, rti_read );
}

inline RTInSignal vbad_inheritance::Conjugate::write( void )
{
	return RTInSignal( this, rti_write );
}

#endif /* vbad_inheritance_H */

// }}}RME
