// {{{RME classifier 'Logical View::VANT::VSUP::Common_VSUP::vcal_protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "vcal_protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <vcal_protocol.h>

const RTProtocolDescriptor vcal_protocol::Base::rt_class =
{
	&vbad_inheritance::Base::rt_class
  , &vcal_protocol::Conjugate::rt_class
  , "vcal_protocol"
  , 0
  , 3
  , vcal_protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor vcal_protocol::Base::rt_signals[] =
{
	{
		"informError"
	  , &RTType_char
	  , vcal_protocol::Base::rti_informError
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , vcal_protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , vcal_protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor vcal_protocol::Conjugate::rt_class =
{
	&vbad_inheritance::Conjugate::rt_class
  , &vcal_protocol::Base::rt_class
  , "vcal_protocol"
  , 0
  , 4
  , vcal_protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor vcal_protocol::Conjugate::rt_signals[] =
{
	{
		"read"
	  , &RTType_char
	  , vcal_protocol::Conjugate::rti_read
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , vcal_protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , vcal_protocol::Conjugate::rti_rtUnbound
	}
  , {
		"write"
	  , &RTType_char
	  , vcal_protocol::Conjugate::rti_write
	}
};

// }}}RME
