// {{{RME classifier 'Logical View::VANT::VSUP::Common_VSUP::vcxp_protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "vcxp_protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <vcxp_protocol.h>

const RTProtocolDescriptor vcxp_protocol::Base::rt_class =
{
	&vbad_inheritance::Base::rt_class
  , &vcxp_protocol::Conjugate::rt_class
  , "vcxp_protocol"
  , 0
  , 6
  , vcxp_protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor vcxp_protocol::Base::rt_signals[] =
{
	{
		"Angle"
	  , &RTType_int
	  , vcxp_protocol::Base::rti_Angle
	}
  , {
		"Heading"
	  , &RTType_int
	  , vcxp_protocol::Base::rti_Heading
	}
  , {
		"Parametro"
	  , &RTType_int
	  , vcxp_protocol::Base::rti_Parametro
	}
  , {
		"Roll"
	  , &RTType_int
	  , vcxp_protocol::Base::rti_Roll
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , vcxp_protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , vcxp_protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor vcxp_protocol::Conjugate::rt_class =
{
	&vbad_inheritance::Conjugate::rt_class
  , &vcxp_protocol::Base::rt_class
  , "vcxp_protocol"
  , 0
  , 4
  , vcxp_protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor vcxp_protocol::Conjugate::rt_signals[] =
{
	{
		"read"
	  , &RTType_char
	  , vcxp_protocol::Conjugate::rti_read
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , vcxp_protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , vcxp_protocol::Conjugate::rti_rtUnbound
	}
  , {
		"write"
	  , &RTType_char
	  , vcxp_protocol::Conjugate::rti_write
	}
};

// }}}RME
