// {{{RME classifier 'Logical View::VANT::VSUP::Common_VSUP::vcxp_protocol'

#ifndef vcxp_protocol_H
#define vcxp_protocol_H

#ifdef PRAGMA
#pragma interface "vcxp_protocol.h"
#endif

#include <RTSystem/VANT.h>
#include <vbad_inheritance.h>

struct vcxp_protocol
{
	class Base : public vbad_inheritance::Base
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum
		{
			rti_Parametro = rtiLast_vbad_inheritance + 1
		  , rti_Angle
		  , rti_Heading
		  , rti_Roll
		};

	protected:
		enum { rtiLast_vcxp_protocol = rti_Roll };

	public:
		inline RTInSignal Parametro( void );
		inline RTInSignal Angle( void );
		inline RTInSignal Heading( void );
		inline RTInSignal Roll( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public vbad_inheritance::Conjugate
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );

	protected:
		enum { rtiLast_vcxp_protocol = rtiLast_vbad_inheritance };

	public:
		inline RTOutSignal Parametro( const int & data );
		inline RTOutSignal Angle( const int & data );
		inline RTOutSignal Heading( const int & data );
		inline RTOutSignal Roll( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline vcxp_protocol::Base::Base( void )
	: vbad_inheritance::Base()
{
}

inline vcxp_protocol::Base::~Base( void )
{
}

inline RTInSignal vcxp_protocol::Base::Parametro( void )
{
	return RTInSignal( this, rti_Parametro );
}

inline RTInSignal vcxp_protocol::Base::Angle( void )
{
	return RTInSignal( this, rti_Angle );
}

inline RTInSignal vcxp_protocol::Base::Heading( void )
{
	return RTInSignal( this, rti_Heading );
}

inline RTInSignal vcxp_protocol::Base::Roll( void )
{
	return RTInSignal( this, rti_Roll );
}

inline vcxp_protocol::Conjugate::Conjugate( void )
	: vbad_inheritance::Conjugate()
{
}

inline vcxp_protocol::Conjugate::~Conjugate( void )
{
}

inline RTOutSignal vcxp_protocol::Conjugate::Parametro( const int & data )
{
	return RTOutSignal( this, Base::rti_Parametro, &data, &RTType_int );
}

inline RTOutSignal vcxp_protocol::Conjugate::Angle( const int & data )
{
	return RTOutSignal( this, Base::rti_Angle, &data, &RTType_int );
}

inline RTOutSignal vcxp_protocol::Conjugate::Heading( const int & data )
{
	return RTOutSignal( this, Base::rti_Heading, &data, &RTType_int );
}

inline RTOutSignal vcxp_protocol::Conjugate::Roll( const int & data )
{
	return RTOutSignal( this, Base::rti_Roll, &data, &RTType_int );
}

#endif /* vcxp_protocol_H */

// }}}RME
